package ch.usi.inf.sape.algoprof.example.array.multidimensional;

import ch.usi.inf.sape.algoprof.statistics.Algorithm;
import ch.usi.inf.sape.algoprof.statistics.AlgorithmCounterVisitor;
import ch.usi.inf.sape.algoprof.statistics.AlgorithmVisitor;
import ch.usi.inf.sape.algoprof.statistics.Configuration;

public class IntegerArray implements Algorithm {
	
	private int[][] intArray;
	
	private int counter;
	private int size;
	
	public IntegerArray(final int verticalSize, final int horizontalSize) {
		counter = 0;
		size = verticalSize*horizontalSize;
		intArray = new int[verticalSize][horizontalSize];
	}
	
	public void fillArray() {

		for (int i=0; i<intArray.length; i++) {
			counter++;
			int[] inner = intArray[i];
			for (int j=0; j<inner.length; j++) {
				intArray[i][j] = (int) (Math.random()*1000);
				counter++;
			}
		}
	}
	
	public void traverse () {
		counter = 0;
		int sum = 0;
		for (int i=0; i<intArray.length; i++) {
			counter++;
			int[] inner = intArray[i];
			for (int j=0; j<inner.length; j++) {
				sum = sum + intArray[i][j];
				counter++;
			}
		}
		System.out.println("sum is " + sum);
	}

	public void accept(AlgorithmVisitor visitor) {
		visitor.visit(this);
	}
	
	public String getData() {
		return size + "\t" + counter + "\n";
	}
	

}
