package ch.usi.inf.sape.algoprof.example.array.multidimensional.local;

import ch.usi.inf.sape.algoprof.statistics.Algorithm;
import ch.usi.inf.sape.algoprof.statistics.AlgorithmVisitor;

public class IntegerArray implements Algorithm  {
	
	private int[][] intArray;
	private int counter;
	private int size;
	
	public IntegerArray(final int verticalSize, final int horizontalSize) {
		counter = 0;
		size = verticalSize*horizontalSize;
		intArray = new int[verticalSize][horizontalSize];
		
	}
	
	public int[][] fillArray() {
		for (int i=0; i<intArray.length; i++) {
			counter++;
			int[] inner = intArray[i];
			for (int j=0; j<inner.length; j++) {
				counter++;
				intArray[i][j] = (int) (Math.random()*1000);
			}
		}
		return intArray;
	}
	
	public void traverse (int[][] arr) {
		int sum = 0;
		counter=0;
		for (int i=0; i<arr.length; i++) {
			counter++;
			int[] inner = intArray[i];
			for (int j=0; j<inner.length; j++) {
				counter++;
				sum = sum + inner[j];
			}
		}
		System.out.println("sum is " + sum);
	}

	public void accept(AlgorithmVisitor visitor) {
		visitor.visit(this);
	}
	
	public String getData() {
		return size + "\t" + counter + "\n";
	}

}
