package ch.usi.inf.sape.algoprof.example.array.multidimensional.local;

import ch.usi.inf.sape.algoprof.statistics.Algorithm;
import ch.usi.inf.sape.algoprof.statistics.AlgorithmCounterVisitor;
import ch.usi.inf.sape.algoprof.statistics.AlgorithmRepetitionTreeVisitor;
import ch.usi.inf.sape.algoprof.statistics.AlgorithmVisitor;
import ch.usi.inf.sape.algoprof.statistics.Configuration;


public class Main implements Algorithm {
	
	public static void main(String[] args) {
		
		new Main().harness();
		
		
	}
	
	public void harness() {
		boolean once = true;
		AlgorithmCounterVisitor fillVisitor = null;
		AlgorithmCounterVisitor traverseVisitor = null;
		AlgorithmVisitor av = null;
		if (Configuration.ENABLE_MANUAL_INSTRUMENTATION) {
			fillVisitor = new AlgorithmCounterVisitor("fillArray", "/src/ch/usi/inf/sape/algoprof/example/array/multidimensional/local/", "int[][] modification");
			traverseVisitor = new AlgorithmCounterVisitor("traverse", "/src/ch/usi/inf/sape/algoprof/example/array/multidimensional/local/", "LV int[][] traversal");
			av = new AlgorithmRepetitionTreeVisitor();
			accept(av);
		}
		for (int i=1; i<=10; i++) {
			IntegerArray ia = new IntegerArray(i, 5*i);
			if (once && Configuration.ENABLE_MANUAL_INSTRUMENTATION) {
				once = false;
				ia.accept(av);
			}
			int[][] a = ia.fillArray();
			if (Configuration.ENABLE_MANUAL_INSTRUMENTATION) {
				ia.accept(fillVisitor);				
			}
			ia.traverse(a);
			if (Configuration.ENABLE_MANUAL_INSTRUMENTATION) {
				ia.accept(traverseVisitor);				
			}
		}
		
		if (Configuration.ENABLE_MANUAL_INSTRUMENTATION) {
			accept(fillVisitor);
			accept(traverseVisitor);	
		}
		
	}

	public void accept(AlgorithmVisitor visitor) {
		visitor.visit(this);		
	}

}
