package ch.usi.inf.sape.algoprof.example.graph.directed.linked.basic;

import java.util.ArrayList;


public class Node {

	private int id;
	private boolean marked;
	private final ArrayList<Node> directSuccessors;
	
	
	public Node() {
		marked = false;
		directSuccessors = new ArrayList<Node>();
	}
	
	public boolean isMarked() {
		return marked;
	}
	
	public void mark() {
		marked = true;
	}
	
	public void clear() {
		marked = false;
	}
	
	public void setId(final int id) {
		this.id = id;
	}
	
	public int getId() {
		return id;
	}
	
	public void addDirectSuccessor(final Node node) {
		directSuccessors.add(node);
	}
	
	public int getOutDegree() {
		return directSuccessors.size();
	}
	
	public Node getDirectSuccessor(final int i) {
		return directSuccessors.get(i);
	}

}
