package ch.usi.inf.sape.algoprof.example.graph.undirected.linked.basic;

import java.util.ArrayList;


public class Node {

	private int id;
	private boolean marked;
	private final ArrayList<Node> neighbors;
	
	
	public Node() {
		marked = false;
		neighbors = new ArrayList<Node>();
	}
	
	public boolean isMarked() {
		return marked;
	}
	
	public void mark() {
		marked = true;
	}
	
	public void clear() {
		marked = false;
	}
	
	public void setId(final int id) {
		this.id = id;
	}
	
	public int getId() {
		return id;
	}
	
	public void addNeighbor(final Node node) {
		neighbors.add(node);
	}
	
	public int getDegree() {
		return neighbors.size();
	}
	
	public Node getNeighbor(final int i) {
		return neighbors.get(i);
	}
	
}
