package ch.usi.inf.sape.algoprof.example.list.array.doubling.basic;

import ch.usi.inf.sape.algoprof.statistics.Algorithm;
import ch.usi.inf.sape.algoprof.statistics.AlgorithmVisitor;


public class ArrayList implements Algorithm {

	private String[] array;
	private int size;
	private int counter;
	
	
	public ArrayList() {
		array = new String[1];
		counter = 0;
	}
	
	public void increaseCounter() {
		counter++;
	}
	
	private void growIfFull() {
		if (size==array.length) {
			// I expect this doubling of size to lead to inaccuracies in profiler (it won't know that some elements are unused)
			final String[] newArray = new String[array.length*2];
			for (int i=0; i<array.length; i++) {
				counter++;
				//StaticCounter.counter++;
				newArray[i] = array[i];
			}
			array = newArray;
		}
	}
	
	public void append(final String value) {
		growIfFull();
		array[size++] = value;
		System.out.println(array.length  + " xex");
		//System.out.println(array[size-1]);
	}
	
	public int length() {
		return size;
	}
	
	public void iterativePrint() {
		counter = 0;
		for (int i=0; i<size; i++) {
			counter++;
			System.out.print(array[i]+" ");
		}
		System.out.println();
	}
	
	public void recursivePrint() {
		counter = 0;
		recursivePrintFrom(0);
		System.out.println();
	}
	
	private void recursivePrintFrom(final int index) {
		counter++;
		if (index<size) {
			System.out.print(array[index]+" ");
			recursivePrintFrom(index+1);			
		}
	}
	
	// indexOf
	public int iterativeIndexOf(final String value) {
		counter = 0;
		for (int i = 0; i < size; i++) {
			counter++;
			if (value.equals(array[i])) {
				return i;
			}
		}
		return -1;
	}
	
	public int recursiveIndexOf(final String value) {
		counter = 0;
		return recursiveIndexOfFrom(value, 0);
	}
	
	private int recursiveIndexOfFrom(final String value, int index) {
		counter++;
		if (index<size) {
			if (value.equals(array[index])) {
				return index;
			}
			return recursiveIndexOfFrom(value, index+1);
		} else {
			return -1;
		}
	}

	public void accept(AlgorithmVisitor visitor) {
		visitor.visit(this);
		
	}
	
	public String getData() {
		return size + "\t" + counter + "\n";
	}

}
