package ch.usi.inf.sape.algoprof.example.list.array.naive.basic;

import ch.usi.inf.sape.algoprof.example.list.array.doubling.basic.StaticCounter;
import ch.usi.inf.sape.algoprof.statistics.Algorithm;
import ch.usi.inf.sape.algoprof.statistics.AlgorithmVisitor;


public class ArrayList implements Algorithm {

	private String[] array;
	private int counter;
	private int size;
	
	public ArrayList() {
		array = new String[0];
		counter = 0;
		size = array.length;
	}
	
	public void increaseCounter() {
		counter++;
	}
	
	private void grow() {
		final String[] newArray = new String[array.length+1];
		size = newArray.length;
		for (int i=0; i<array.length; i++) {
			counter++;
			newArray[i] = array[i];
			StaticCounter.counter++;
		}
		array = newArray;
	}
	
	public void append(final String value) {
		grow();
		array[array.length-1] = value;
	}
	
	public int length() {
		return array.length;
	}
	
	public void iterativePrint() {
		counter = 0;
		size = array.length;
		for (int i=0; i<array.length; i++) {
			counter++;
			System.out.print(array[i]+" ");
		}
		System.out.println();
	}
	
	public void iterativePrintForEach() {
		counter = 0;
		size = array.length;
		for (final String value : array) {
			counter++;
			System.out.print(value+" ");
		}
		System.out.println();
	}
	
	public void recursivePrint() {
		counter = 0;
		size = array.length;
		recursivePrintFrom(0);
		System.out.println();
	}
	
	private void recursivePrintFrom(final int index) {
		counter++;
		if (index<array.length) {
			System.out.print(array[index]+" ");
			recursivePrintFrom(index+1);
		}
	}
	
	// indexOf
	public int iterativeIndexOf(final String value) {
		counter = 0;
		size = array.length;
		for (int i = 0; i < array.length; i++) {
			counter++;
			if (value.equals(array[i])) {
				return i;
			}
		}
		return -1;
	}
	
	public int recursiveIndexOf(final String value) {
		counter = 0;
		size = array.length;
		return recursiveIndexOfFrom(value, 0);
	}
	
	private int recursiveIndexOfFrom(final String value, int index) {
		counter++;
		if (index<array.length) {
			if (value.equals(array[index])) {
				return index;
			}
			return recursiveIndexOfFrom(value, index+1);
		} else {
			return -1;
		}
	}

	public void accept(AlgorithmVisitor visitor) {
		visitor.visit(this);
		
	}
	public String getData() {
		return size + "\t" + counter + "\n";
	}
	
}
