package ch.usi.inf.sape.algoprof.example.list.linked.generic;


public class Node<T> {

	private final T value;
	private final Node<T> rest;
	
	
	public Node(final T value, final Node<T> rest) {
		this.value = value;
		this.rest = rest;
	}
	
	public T getValue() {
		return value;
	}
	
	public Node<T> getRest() {
		return rest;
	}
	
	public int recursiveLength() {
		if (rest==null) {
			return 1;
		} else {
			return 1+rest.recursiveLength();
		}
	}
	
	public void recursivePrint() {
		if (rest==null) {
			System.out.println(value+" ");
		} else {
			System.out.print(value+" ");
			rest.recursivePrint();
		}
	}
	
	public int recursiveIndexOf(final T value, final int index) {
		if (value.equals(this.value)) {
			return index;
		} else {
			if (rest==null) {
				return -1;
			} else {
				return rest.recursiveIndexOf(value, index+1);
			}
		}
	}
	
}
