package ch.usi.inf.sape.algoprof.example.list.linked.inheritance;


public class PongNode implements Node {

	private final String value;
	private final Node rest;
	
	
	public PongNode(final String value, final Node rest) {
		this.value = value;
		this.rest = rest;
	}
	
	public String getValue() {
		return value;
	}
	
	public Node getRest() {
		return rest;
	}
	
	public int recursiveLength() {
		if (rest==null) {
			return 1;
		} else {
			return 1+rest.recursiveLength();
		}
	}
	
	public void recursivePrint() {
		if (rest==null) {
			System.out.println(value+" ");
		} else {
			System.out.print(value+" ");
			rest.recursivePrint();
		}
	}
	
	public int recursiveIndexOf(final String value, final int index) {
		if (value.equals(this.value)) {
			return index;
		} else {
			if (rest==null) {
				return -1;
			} else {
				return rest.recursiveIndexOf(value, index+1);
			}
		}
	}

}
