package ch.usi.inf.sape.algoprof.example.sort.insertion2;

import ch.usi.inf.sape.algoprof.statistics.Algorithm;
import ch.usi.inf.sape.algoprof.statistics.AlgorithmCounterVisitor;
import ch.usi.inf.sape.algoprof.statistics.AlgorithmRepetitionTreeVisitor;
import ch.usi.inf.sape.algoprof.statistics.AlgorithmVisitor;
import ch.usi.inf.sape.algoprof.statistics.Configuration;

public class InsertionSortAlgorithm implements Algorithm {
    
	private int counter = 0;
	private int size = 0;
	private boolean last = false;

	public static void main(String a[]){
		new InsertionSortAlgorithm().harness();
	}
	
	public int[] fillArray (int size) {
		int[] arr = new int [size];

		for (int i = 0; i<size; i++) {
			counter++;
			arr[i] = (int)(Math.random()*1000);
			//System.out.println(arr[i]);
		}


		return arr;
	}
	
	public void harness() {
		int length = 100;
		AlgorithmVisitor sortVisitor = null;
		AlgorithmVisitor fillVisitor = null;
  	    AlgorithmVisitor av = null;
  	  
  	    if (Configuration.ENABLE_MANUAL_INSTRUMENTATION) {
			  av = new AlgorithmRepetitionTreeVisitor();
			  sortVisitor = new AlgorithmCounterVisitor("sort", "/src/ch/usi/inf/sape/algoprof/example/sort/insertion2/", "sorting array");  
			  fillVisitor = new AlgorithmCounterVisitor("fillArray", "/src/ch/usi/inf/sape/algoprof/example/sort/insertion2/", "filling array with random numbers");  		
			  accept(av);    			    	
		}
		try {
			for (int i = 1; i<=length; i=i*10) {
				for (int j=0; j<3; j++) {
				
					if (i==length && j == 2) {
						last = true;
					}
					size = i;
					counter = 0;
					int arr[] = fillArray(i);
					if (Configuration.ENABLE_MANUAL_INSTRUMENTATION) {
						accept(fillVisitor);
					}
					counter = 0;
					sort(arr);
					if (Configuration.ENABLE_MANUAL_INSTRUMENTATION) {
						accept(sortVisitor);
					}
					//System.out.println(i);
				}
			}

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public void sort(int a[]) throws Exception {
		for (int i = 1; i < a.length; i++) {
			counter++;
		    int j = i;
		    int B = a[i];
		    while ((j > 0) && (a[j-1] > B)) {
		    	counter++;
	            a[j] = a[j-1];
		        j--;
		    }
		    a[j] = B;
	    }
    }
    public void accept(AlgorithmVisitor visitor) {
		visitor.visit(this);
		
	}
	

	public String getData() {
		return size + "\t" + counter + "\n";
	}
	
	public boolean isLast() {
		return last;	
	}

}

