package ch.usi.inf.sape.algoprof.example.sort.insertion3;


import ch.usi.inf.sape.algoprof.statistics.Algorithm;
import ch.usi.inf.sape.algoprof.statistics.AlgorithmCounterVisitor;
import ch.usi.inf.sape.algoprof.statistics.AlgorithmRepetitionTreeVisitor;
import ch.usi.inf.sape.algoprof.statistics.AlgorithmVisitor;
import ch.usi.inf.sape.algoprof.statistics.Configuration;

public class Main implements Algorithm {
	
	private int size = 0;
	private boolean last = false;
	private Cons cons = null;
	public static void main(String a[]){
		new Main().harness();
	}

	public void fillArray (int size, List cons) {
		
		Cons.counter++;
		if (size!=0) {
			size--;
			fillArray(size, new Cons((int)(Math.random()*1000), cons));
		} else {
			this.cons = (Cons)cons;
		}
		return;
		}


	public void harness() {
		int length = 10;
		AlgorithmVisitor sortVisitor = null;
		AlgorithmVisitor fillVisitor = null;
		AlgorithmVisitor av = null;

		if (Configuration.ENABLE_MANUAL_INSTRUMENTATION) {
			av = new AlgorithmRepetitionTreeVisitor();
			sortVisitor = new AlgorithmCounterVisitor("sort", "/src/ch/usi/inf/sape/algoprof/example/sort/insertion3/", "sorting array");  
			fillVisitor = new AlgorithmCounterVisitor("fillArray", "/src/ch/usi/inf/sape/algoprof/example/sort/insertion3/", "filling array with random numbers");  		

			accept(av);    			    	
		}

		try {
			for (int i = 1; i<=length; i=i+1) {
				for (int j=0; j<3; j++) {

					if (i==length && j == 2) {
						last = true;
					}
					size = i;
					Cons.counter = 0;
					fillArray(i, new Empty());
					if (Configuration.ENABLE_MANUAL_INSTRUMENTATION) {
						accept(fillVisitor);
					}
					Cons.counter = 0;
					cons.sort();
					if (Configuration.ENABLE_MANUAL_INSTRUMENTATION) {
						accept(sortVisitor);
					}
					System.out.println(i + " " + Cons.counter);
				}
			}
			System.out.println("done");

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	
	public void accept(AlgorithmVisitor visitor) {
		visitor.visit(this);
	}

	public String getData() {
		return size + "\t" + Cons.counter + "\n";
	}

	public boolean isLast() {
		return last;	
	}
}
