package ch.usi.inf.sape.algoprof.example.tree.array.perfect.binary;

import ch.usi.inf.sape.algoprof.statistics.Algorithm;
import ch.usi.inf.sape.algoprof.statistics.AlgorithmVisitor;


public class BinaryTree implements Algorithm {

	private int[] values;
	private int counter;
	private int size;
	
	
	public BinaryTree(final int height) {
		values = new int[heightToNodeCount(height)];
		counter = 0;
		size = heightToNodeCount(height);
		number(getRootId(), 1);
	}
	
	private int number(final int nodeId, final int value) {
		int v = value;
		values[nodeId] = v++;
		final int leftChildId = getLeftChildId(nodeId);
		if (leftChildId<values.length) {
			counter++;
			v = number(leftChildId, v);
		}
		final int rightChildId = getRightChildId(nodeId);
		if (rightChildId<values.length) {
			counter++;
			v = number(rightChildId, v);
		}
		return v;
	}
	
	private int heightToNodeCount(final int height) {
		return (int)(Math.pow(2, height+1)-1);
	}
	
	public int getValue(final int nodeId) {
		return values[nodeId];
	}
	
	public int getRootId() {
		return 0;
	}
	
	public int getLeftChildId(final int parentId) {
		return 2*parentId+1;
	}
	
	public int getRightChildId(final int parentId) {
		return 2*parentId+2;
	}
	
	public int getParentId(final int childId) {
		return (childId-1)/2;
	}
	
	public void recursivePrint() {
		counter = 0;
		recursivePrintFrom(getRootId());
		System.out.println();
	}
	
	private void recursivePrintFrom(final int nodeId) {
		System.out.print(values[nodeId]);
		System.out.print("(");
		final int leftChildId = getLeftChildId(nodeId);
		if (leftChildId<values.length) {
			counter++;
			recursivePrintFrom(leftChildId);
		}
		System.out.print(",");
		final int rightChildId = getRightChildId(nodeId);
		if (rightChildId<values.length) {
			counter++;
			recursivePrintFrom(rightChildId);
		}
		System.out.print(")");
	}

	public void accept(AlgorithmVisitor visitor) {
		visitor.visit(this);
		
	}
	
	public String getData() {
		return size + "\t" + counter + "\n";
	}
	
}
