package ch.usi.inf.sape.algoprof.example.tree.linked.perfect.binary.basic;

import ch.usi.inf.sape.algoprof.statistics.Algorithm;
import ch.usi.inf.sape.algoprof.statistics.AlgorithmVisitor;


public class BinaryTree implements Algorithm {

	private Node root;
	private int counter;
	private int size;
	
	public BinaryTree(final int height) {
		root = new Node(""+1);
		counter = 0;
		size = (int)(Math.pow(2, height+1)-1);
		addDescendants(root, height, 2);
	}
	
	private int addDescendants(final Node node, final int height, final int value) {
		counter++;
		if (height>0) {
			final Node left = new Node(""+value);
			node.setLeft(left);
			final int newValue = addDescendants(left, height-1, value+1);
			final Node right = new Node(""+newValue);
			node.setRight(right);
			final int finalValue = addDescendants(right, height-1, newValue+1);
			return finalValue;
		} else {
			return value;
		}
	}
	
	public Node getRoot() {
		return root;
	}
	
	public void nodeRecursivePrint() {
		counter = 0;
		if (root!=null) {
			counter = root.print(0);
		}
		System.out.println();
	}
	
	public void recursivePrint() {
		counter = 0;
		recursivePrintFrom(root);
		System.out.println();
	}
	
	public void recursivePrintFrom(final Node node) {
		counter++;
		if (node!=null) {
			System.out.print(node.getValue());
			System.out.print("(");
			recursivePrintFrom(node.getLeft());
			System.out.print(",");
			recursivePrintFrom(node.getRight());
			System.out.print(")");
		}
	}

	public void accept(AlgorithmVisitor visitor) {
		visitor.visit(this);
		
	}
	public String getData() {
		return size + "\t" + counter + "\n";
	}
	
}
