package ch.usi.inf.sape.algoprof.example.tree.linked.perfect.nary.basic.bidi;

import ch.usi.inf.sape.algoprof.statistics.Algorithm;
import ch.usi.inf.sape.algoprof.statistics.AlgorithmVisitor;


public class NaryTree implements Algorithm {

	private Node root;
	private int counter;
	private int size;
	int max = 5;
	
	
	public NaryTree(final int height, final int branchingFactor) {
		root = new Node(""+1);
		counter = 0;
		size = (int)(Math.pow(branchingFactor, height+1)-1)/(branchingFactor-1);
		addDescendants(root, height, branchingFactor, 2);
	}

	private int addDescendants(final Node node, final int height, final int branchingFactor, final int value) {
		counter++;
		if (height>0) {
			int v = value;
			if (node.getNumberOfChildren()<max) {
				for (int c=0; c<branchingFactor; c++) {
					final Node child = new Node(""+(v++));
					node.addChild(child);
					child.setParent(node);
					v = addDescendants(child, height-1, branchingFactor, v);
				}
			}
			return v;
		} else {
			return value;
		}
	}
	
	public Node getRoot() {
		return root;
	}
	
	public void nodeRecursivePrint() {
		counter = 0;
		if (root!=null) {
			counter = root.print(0);
		}
		System.out.println();
	}
	
	public void recursivePrint() {
		counter = 0;
		recursivePrintFrom(root);
		System.out.println();
	}
	
	public void recursivePrintFrom(final Node node) {
		counter++;
		if (node!=null) {
			System.out.print(node.getValue());
			System.out.print("(");
			int number = node.getNumberOfChildren();
			for (int c=0; c<number; c++) {
				recursivePrintFrom(node.getChild(c));
				if (c<node.getNumberOfChildren()-1) {
					System.out.print(",");
				}
			}
			System.out.print(")");
		}
	}

	public void accept(AlgorithmVisitor visitor) {
		visitor.visit(this);
	}
	public String getData() {
		return size + "\t" + counter + "\n";
	}

}
