package ch.usi.inf.sape.algoprof.example.tree.linked.perfect.nary.basic.bidi;

import java.util.ArrayList;


public class Node {

	private String value;
	private Node parent;
	private ArrayList<Node> children;

	
	public Node(final String value) {
		this.value = value;
		children = new ArrayList<Node>();
	}
	
	public String getValue() {
		return value;
	}
	
	public Node getParent() {
		return parent;
	}
	
	public void setParent(final Node parent) {
		this.parent = parent;
	}
	
	public void addChild(final Node child) {
		children.add(child);
	}
	
	public int getNumberOfChildren() {
		return children.size();
	}
	
	public Node getChild(final int index) {
		return children.get(index);
	}
	
	public int print(int counter) {
		counter++;
		System.out.print(value);
		System.out.print("(");
		int number = children.size();
		for (int c=0; c<number; c++) {
			final Node child = children.get(c);
			if (child!=null) {
				counter = child.print(counter);
			}
			if (c<children.size()-1) {
				System.out.print(",");
			}
		}
		System.out.print(")");
		return counter;
	}

}
