package ch.usi.inf.sape.algoprof.statistics;


import ch.usi.inf.sape.algoprof.example.array.multidimensional.IntegerArray;
import ch.usi.inf.sape.algoprof.example.array.multidimensional.Main;
import ch.usi.inf.sape.algoprof.example.graph.directed.adjacencymatrix.basic.Graph;
import ch.usi.inf.sape.algoprof.example.graph.directed.linked.basic.Node;
import ch.usi.inf.sape.algoprof.example.list.array.doubling.basic.ArrayList;
import ch.usi.inf.sape.algoprof.example.list.array.naive.inheritance2.PingValue;
import ch.usi.inf.sape.algoprof.example.list.array.naive.inheritance2.PongValue;
import ch.usi.inf.sape.algoprof.example.list.linked.basic.LinkedList;
import ch.usi.inf.sape.algoprof.example.list.linked.inheritance.PingNode;
import ch.usi.inf.sape.algoprof.example.list.linked.inheritance.PongNode;
import ch.usi.inf.sape.algoprof.example.sort.insertion.List;
import ch.usi.inf.sape.algoprof.example.sort.insertion2.InsertionSortAlgorithm;
import ch.usi.inf.sape.algoprof.example.tree.array.perfect.binary.BinaryTree;
import ch.usi.inf.sape.algoprof.example.tree.linked.perfect.nary.basic.NaryTree;

public class AlgorithmRepetitionTreeVisitor implements AlgorithmVisitor {

	private DotWriter dw;
	
	public AlgorithmRepetitionTreeVisitor() {
		// TODO Auto-generated constructor stub
	}
	
	public AlgorithmRepetitionTreeVisitor(DotWriter dw) {
		this.dw = dw;
	}
	
	public void visit(IntegerArray ia) {
		String nodeName1 = dw.createNode(ia.getClass().getSimpleName(), "fillArray", 23, true);
		String nodeName2 = dw.createNode(ia.getClass().getSimpleName(), "fillArray", 26, true);
		dw.connect("Main_harness_17", nodeName1);
		dw.connect(nodeName1, nodeName2);
		dw.createSubgraph("filling int[][] array", "size", 2);
		String nodeName3 = dw.createNode(ia.getClass().getSimpleName(), "traverse", 35, true);
		String nodeName4 = dw.createNode(ia.getClass().getSimpleName(), "traverse", 37, true);
		dw.connect("Main_harness_17", nodeName3);
		dw.connect(nodeName3, nodeName4);
		dw.createSubgraph("traversing int[][] array", "size", 3);
		
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/array/multidimensional");
		
	}

	public void visit(Main m) {
		dw = new DotWriter();	
		String name = dw.createNode(m.getClass().getSimpleName(), "harness", 17, true);
		dw.createSubgraph("Harness", "size", 1);
		
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.array.multidimensional.local.IntegerArray ia) {
		String nodeName1 = dw.createNode(ia.getClass().getSimpleName(), "fillArray", 20, true);
		String nodeName2 = dw.createNode(ia.getClass().getSimpleName(), "fillArray", 22, true);
		dw.connect("Main_harness_30", nodeName1);
		dw.connect(nodeName1, nodeName2);
		dw.createSubgraph("filling int[][] array", "size", 2);
		String nodeName3 = dw.createNode(ia.getClass().getSimpleName(), "traverse", 33, true);
		String nodeName4 = dw.createNode(ia.getClass().getSimpleName(), "traverse", 35, true);
		dw.connect("Main_harness_30", nodeName3);
		dw.connect(nodeName3, nodeName4);
		dw.createSubgraph("traversing int[][] array", "size", 3);
		
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/array/multidimensional/local");
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.array.multidimensional.local.Main m) {
		dw = new DotWriter();	
		String name = dw.createNode(m.getClass().getSimpleName(), "harness", 30, true);
		dw.createSubgraph("Harness", "size", 1);
		
	}

	public void visit(Graph g) {
		String nodeName1 = dw.createNode(g.getClass().getSimpleName(), "makeComplete", 20, true);
		String nodeName2 = dw.createNode(g.getClass().getSimpleName(), "makeComplete", 21, true);
		dw.connect("Main_harness_38", nodeName1);
		dw.connect(nodeName1, nodeName2);
		dw.createSubgraph("creating graph\\nnode points to all nodes\\nbool edges[node][node]", "nodes*nodes", 2);
		String nodeName3 = dw.createNode(g.getClass().getSimpleName(), "printToDot", 35, true);
		String nodeName4 = dw.createNode(g.getClass().getSimpleName(), "printToDot", 37, true);
		dw.connect("Main_harness_38", nodeName3);
		dw.connect(nodeName3, nodeName4);
		dw.createSubgraph("print graph", "nodes*nodes", 3);
		String nodeName5 = dw.createNode(g.getClass().getSimpleName(), "recursivePrint", 48, true);
		dw.connect("Main_harness_38", nodeName5);
		dw.createSubgraph("mark nodes", "nodes", 4);
		String nodeName6 = dw.createNode(g.getClass().getSimpleName(), "recursivePrint", 53, true);
		String nodeName7 = dw.createNode(g.getClass().getSimpleName(), "recursivePrintFrom", 68, false);
		String nodeName8 = dw.createNode(g.getClass().getSimpleName(), "recursivePrintFrom", 64, true);
		dw.connect("Main_harness_38", nodeName6);
		dw.connect(nodeName6, nodeName7);
		dw.connect(nodeName7, nodeName8);
		dw.createSubgraph("recursively print graph", "nodes*nodes", 5);
		
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/graph/directed/adjacencymatrix/basic");
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.graph.directed.adjacencymatrix.basic.Main m) {
		dw = new DotWriter();	
		String name = dw.createNode(m.getClass().getSimpleName(), "harness", 38, true);
		dw.createSubgraph("Harness", "nodes", 1);
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.graph.directed.linked.basic.Main m) {
		dw = new DotWriter();	
		String name = dw.createNode(m.getClass().getSimpleName(), "harness", 62, true);
		dw.createSubgraph("Harness", "nodes", 0);
		
	}

	public void visit(Node n) {
		// TODO Auto-generated method stub
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.graph.directed.linked.basic.Graph g) {
		String nodeName0 = dw.createNode(g.getClass().getSimpleName(), "makeComplete", 26, true);
		dw.connect("Main_harness_62", nodeName0);
		dw.createSubgraph("creating nodes", "util.List<Node>", 1);
		
		String nodeName1 = dw.createNode(g.getClass().getSimpleName(), "makeComplete", 37, true);
		String nodeName2 = dw.createNode(g.getClass().getSimpleName(), "makeComplete", 40, true);
		dw.connect("Main_harness_62", nodeName1);
		dw.connect(nodeName1, nodeName2);
		dw.createSubgraph("creating graph\\nnode points to all nodes\\nutil.List<Node>", "nodes*nodes", 2);
		String nodeName3 = dw.createNode(g.getClass().getSimpleName(), "printToDot", 68, true);
		String nodeName4 = dw.createNode(g.getClass().getSimpleName(), "printToDot", 72, true);
		dw.connect("Main_harness_62", nodeName3);
		dw.connect(nodeName3, nodeName4);
		dw.createSubgraph("print graph", "nodes*nodes", 3);
		String nodeName5 = dw.createNode(g.getClass().getSimpleName(), "recursivePrint", 87, true);
		dw.connect("Main_harness_62", nodeName5);
		dw.createSubgraph("mark nodes", "nodes", 4);
		String nodeName6 = dw.createNode(g.getClass().getSimpleName(), "recursivePrint", 97, true);
		String nodeName7 = dw.createNode(g.getClass().getSimpleName(), "recursivePrintFrom", 115, false);
		String nodeName8 = dw.createNode(g.getClass().getSimpleName(), "recursivePrintFrom", 111, true);
		dw.connect("Main_harness_62", nodeName6);
		dw.connect(nodeName6, nodeName7);
		dw.connect(nodeName7, nodeName8);
		dw.createSubgraph("recursively print graph", "nodes*nodes", 5);
		
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/graph/directed/linked/basic");
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.graph.directed.linked.basic.bidi.Graph g) {
		String nodeName0 = dw.createNode(g.getClass().getSimpleName(), "makeComplete", 26, true);
		dw.connect("Main_harness_60", nodeName0);
		dw.createSubgraph("creating nodes", "util.List<Node>", 1);
		
		String nodeName1 = dw.createNode(g.getClass().getSimpleName(), "makeComplete", 37, true);
		String nodeName2 = dw.createNode(g.getClass().getSimpleName(), "makeComplete", 40, true);
		dw.connect("Main_harness_60", nodeName1);
		dw.connect(nodeName1, nodeName2);
		dw.createSubgraph("creating graph\\nnode points to all nodes\\nutil.List<Node>", "nodes*nodes", 2);
		String nodeName3 = dw.createNode(g.getClass().getSimpleName(), "printToDot", 69, true);
		String nodeName4 = dw.createNode(g.getClass().getSimpleName(), "printToDot", 73, true);
		dw.connect("Main_harness_60", nodeName3);
		dw.connect(nodeName3, nodeName4);
		dw.createSubgraph("print graph", "nodes*nodes", 3);
		String nodeName5 = dw.createNode(g.getClass().getSimpleName(), "recursivePrint", 86, true);
		dw.connect("Main_harness_60", nodeName5);
		dw.createSubgraph("mark nodes", "nodes", 4);
		String nodeName6 = dw.createNode(g.getClass().getSimpleName(), "recursivePrint", 97, true);
		String nodeName7 = dw.createNode(g.getClass().getSimpleName(), "recursivePrintFrom", 115, false);
		String nodeName8 = dw.createNode(g.getClass().getSimpleName(), "recursivePrintFrom", 111, true);
		dw.connect("Main_harness_60", nodeName6);
		dw.connect(nodeName6, nodeName7);
		dw.connect(nodeName7, nodeName8);
		dw.createSubgraph("recursively print graph", "nodes*nodes", 5);
		
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/graph/directed/linked/basic/bidi");
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.graph.directed.linked.basic.bidi.Main m) {
		dw = new DotWriter();	
		String name = dw.createNode(m.getClass().getSimpleName(), "harness", 60, true);
		dw.createSubgraph("Harness", "nodes", 0);
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.graph.directed.linked.basic.bidi.Node n) {
		// TODO Auto-generated method stub
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.graph.undirected.linked.basic.Graph g) {
		
		String nodeName1 = dw.createNode(g.getClass().getSimpleName(), "makeComplete", 26, true);
		String nodeName2 = dw.createNode(g.getClass().getSimpleName(), "makeComplete", 30, true);
		dw.connect("Main_harness_55", nodeName1);
		dw.connect(nodeName1, nodeName2);
		dw.createSubgraph("creating graph\\nnode points to all nodes\\nutil.List<Node>", "nodes*nodes", 2);
		String nodeName3 = dw.createNode(g.getClass().getSimpleName(), "printToDot", 54, true);
		String nodeName4 = dw.createNode(g.getClass().getSimpleName(), "printToDot", 58, true);
		dw.connect("Main_harness_55", nodeName3);
		dw.connect(nodeName3, nodeName4);
		dw.createSubgraph("print graph", "nodes*nodes", 3);
		String nodeName5 = dw.createNode(g.getClass().getSimpleName(), "recursivePrint", 71, true);
		dw.connect("Main_harness_55", nodeName5);
		dw.createSubgraph("mark nodes", "nodes", 4);
		String nodeName6 = dw.createNode(g.getClass().getSimpleName(), "recursivePrint", 82, true);
		String nodeName7 = dw.createNode(g.getClass().getSimpleName(), "recursivePrintFrom", 100, false);
		String nodeName8 = dw.createNode(g.getClass().getSimpleName(), "recursivePrintFrom", 96, true);
		dw.connect("Main_harness_55", nodeName6);
		dw.connect(nodeName6, nodeName7);
		dw.connect(nodeName7, nodeName8);
		dw.createSubgraph("recursively print graph", "nodes*nodes", 5);
		
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/graph/undirected/linked/basic");
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.graph.undirected.linked.basic.Main m) {

			dw = new DotWriter();	
			String name = dw.createNode(m.getClass().getSimpleName(), "harness", 55, true);
			dw.createSubgraph("Harness", "nodes", 0);
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.graph.undirected.linked.basic.Node n) {
		// TODO Auto-generated method stub
		
	}

	public void visit(ArrayList al) {
		String nodeName0 = dw.createNode("Main", "testForSize", 89, true);
		String nodeName1 = dw.createNode(al.getClass().getSimpleName(), "growIfFull", 27, true);
		dw.connect("Main_harness_62", nodeName0);
		dw.connect(nodeName0, nodeName1);
		dw.createSubgraph("appending elements\\nto List", "ArrayList is String[]", 1);
		
		String nodeName2 = dw.createNode(al.getClass().getSimpleName(), "iterativePrint", 48, true);
		dw.connect("Main_harness_62", nodeName2);
		dw.createSubgraph("simple iterative print", "ArrayList is String[]", 2);
		
		String nodeName3 = dw.createNode(al.getClass().getSimpleName(), "recursivePrintFrom", 65, false);
		dw.connect("Main_harness_62", nodeName3);
		dw.createSubgraph("simple recursive print", "ArrayList is String[]", 3);
		
		String nodeName4 = dw.createNode(al.getClass().getSimpleName(), "iterativeIndexOf", 72, true);
		dw.connect("Main_harness_62", nodeName4);
		dw.createSubgraph("finding index of\\na value, iteratively", "ArrayList is String[]", 4);
		
		String nodeName5 = dw.createNode(al.getClass().getSimpleName(), "recursiveIndexOfFrom", 92, false);
		dw.connect("Main_harness_62", nodeName5);
		dw.createSubgraph("finding index of\\na value recursively", "ArrayList is String[]", 5);
		
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/list/array/doubling/basic");		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.list.array.doubling.basic.Main m) {
		dw = new DotWriter();	
		String name = dw.createNode(m.getClass().getSimpleName(), "harness", 62, true);
		dw.createSubgraph("Harness", "array size", 0);
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.list.array.naive.basic.ArrayList al) {
		String nodeName0 = dw.createNode("Main", "testForSize", 90, true);
		String nodeName1 = dw.createNode(al.getClass().getSimpleName(), "grow", 27, true);
		dw.connect("Main_harness_64", nodeName0);
		dw.connect(nodeName0, nodeName1);
		dw.createSubgraph("appending elements\\nto List", "ArrayList is String[]", 1);
		
		String nodeName2 = dw.createNode(al.getClass().getSimpleName(), "iterativePrint", 47, true);
		dw.connect("Main_harness_64", nodeName2);
		dw.createSubgraph("simple iterative print", "ArrayList is String[]", 2);
		
		String nodeName3 = dw.createNode(al.getClass().getSimpleName(), "iterativePrintForEach", 57, true);
		dw.connect("Main_harness_64", nodeName3);
		dw.createSubgraph("simple iterative print\\nusing for-each", "ArrayList is String[]", 3);
		
		
		String nodeName4 = dw.createNode(al.getClass().getSimpleName(), "recursivePrintFrom", 75, false);
		dw.connect("Main_harness_64", nodeName4);
		dw.createSubgraph("simple recursive print", "ArrayList is String[]", 4);
		
		String nodeName5 = dw.createNode(al.getClass().getSimpleName(), "iterativeIndexOf", 83, true);
		dw.connect("Main_harness_64", nodeName5);
		dw.createSubgraph("finding index of\\na value, iteratively", "ArrayList is String[]", 5);
		
		String nodeName6 = dw.createNode(al.getClass().getSimpleName(), "recursiveIndexOfFrom", 104, false);
		dw.connect("Main_harness_64", nodeName6);
		dw.createSubgraph("finding index of\\na value recursively", "ArrayList is String[]", 6);
		
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/list/array/naive/basic");
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.list.array.naive.basic.Main m) {
		dw = new DotWriter();	
		String name = dw.createNode(m.getClass().getSimpleName(), "harness", 64, true);
		dw.createSubgraph("Harness", "array size", 0);
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.list.array.naive.generic.ArrayList<?> al) {
		String nodeName0 = dw.createNode("Main", "testForSize", 89, true);
		String nodeName1 = dw.createNode(al.getClass().getSimpleName(), "grow", 27, true);
		dw.connect("Main_harness_65", nodeName0);
		dw.connect(nodeName0, nodeName1);
		dw.createSubgraph("appending elements\\nto List", "ArrayList is T[]", 1);
		
		String nodeName2 = dw.createNode(al.getClass().getSimpleName(), "iterativePrint", 46, true);
		dw.connect("Main_harness_65", nodeName2);
		dw.createSubgraph("simple iterative print", "ArrayList is T[]", 2);
		
		String nodeName3 = dw.createNode(al.getClass().getSimpleName(), "iterativePrintForEach", 56, true);
		dw.connect("Main_harness_65", nodeName3);
		dw.createSubgraph("simple iterative print\\nusing for-each", "ArrayList is T[]", 3);
		
		
		String nodeName4 = dw.createNode(al.getClass().getSimpleName(), "recursivePrintFrom", 74, false);
		dw.connect("Main_harness_65", nodeName4);
		dw.createSubgraph("simple recursive print", "ArrayList is T[]", 4);
		
		String nodeName5 = dw.createNode(al.getClass().getSimpleName(), "iterativeIndexOf", 82, true);
		dw.connect("Main_harness_65", nodeName5);
		dw.createSubgraph("finding index of\\na value, iteratively", "ArrayList is T[]", 5);
		
		String nodeName6 = dw.createNode(al.getClass().getSimpleName(), "recursiveIndexOfFrom", 103, false);
		dw.connect("Main_harness_65", nodeName6);
		dw.createSubgraph("finding index of\\na value recursively", "ArrayList is T[]", 6);
		
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/list/array/naive/generic");
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.list.array.naive.generic.Main m) {
		dw = new DotWriter();	
		String name = dw.createNode(m.getClass().getSimpleName(), "harness", 65, true);
		dw.createSubgraph("Harness", "array size", 0);
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.list.array.naive.inheritance2.ArrayList al) {
		String nodeName0 = dw.createNode("Main", "testForSize", 88, true);
		String nodeName1 = dw.createNode(al.getClass().getSimpleName(), "grow", 26, true);
		dw.connect("Main_harness_63", nodeName0);
		dw.connect(nodeName0, nodeName1);
		dw.createSubgraph("appending elements\\nto List", "ArrayList is Value[]", 1);
		
		String nodeName2 = dw.createNode(al.getClass().getSimpleName(), "iterativePrint", 45, true);
		dw.connect("Main_harness_63", nodeName2);
		dw.createSubgraph("simple iterative print", "ArrayList is Value[]", 2);
		
		String nodeName3 = dw.createNode(al.getClass().getSimpleName(), "iterativePrintForEach", 55, true);
		dw.connect("Main_harness_63", nodeName3);
		dw.createSubgraph("simple iterative print\\nusing for-each", "ArrayList is Value[]", 3);
		
		
		String nodeName4 = dw.createNode(al.getClass().getSimpleName(), "recursivePrintFrom", 73, false);
		dw.connect("Main_harness_63", nodeName4);
		dw.createSubgraph("simple recursive print", "ArrayList is Value[]", 4);
		
		String nodeName5 = dw.createNode(al.getClass().getSimpleName(), "iterativeIndexOf", 81, true);
		dw.connect("Main_harness_63", nodeName5);
		dw.createSubgraph("finding index of\\na value, iteratively", "ArrayList is Value[]", 5);
		
		String nodeName6 = dw.createNode(al.getClass().getSimpleName(), "recursiveIndexOfFrom", 102, false);
		dw.connect("Main_harness_63", nodeName6);
		dw.createSubgraph("finding index of\\na value recursively", "ArrayList is Value[]", 6);
		
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/list/array/naive/inheritance2");
		
	}

	public void visit(PingValue ping) {
		// TODO Auto-generated method stub
		
	}

	public void visit(PongValue pong) {
		// TODO Auto-generated method stub
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.list.array.naive.inheritance2.Main m) {
		dw = new DotWriter();	
		String name = dw.createNode(m.getClass().getSimpleName(), "harness", 63, true);
		dw.createSubgraph("Harness", "array size", 0);
		
	}

	public void visit(LinkedList ll) {
		String nodeName1 = dw.createNode("Main", "testForSize", 108, true);
		dw.connect("Main_harness_78", nodeName1);
		dw.createSubgraph("appending elements\\nto List", "LinkedList of nodes", 1);
		
		String nodeName2 = dw.createNode(ll.getClass().getSimpleName(), "iterativeLength", 35, true);
		dw.connect("Main_harness_78", nodeName2);
		dw.createSubgraph("counting length\\nof LinkedList", "LinkedList of nodes", 2);
		
		String nodeName3 = dw.createNode("Node", "recursiveLength", 27, false);
		dw.connect("Main_harness_78", nodeName3);
		dw.createSubgraph("counting length\\non Node", "LinkedList of nodes", 3);	
		
		String nodeName4 = dw.createNode(ll.getClass().getSimpleName(), "recursiveLengthFrom", 61, false);
		dw.connect("Main_harness_78", nodeName4);
		dw.createSubgraph("counting length\\nof LinkedList", "LinkedList of nodes", 4);
		
		String nodeName5 = dw.createNode(ll.getClass().getSimpleName(), "iterativeIndexOf", 69, true);
		dw.connect("Main_harness_78", nodeName5);
		dw.createSubgraph("finding index of\\nNode, iteratively", "LinkedList of nodes", 5);
		
		String nodeName6 = dw.createNode("Node", "recursiveIndexOf", 47, false);
		dw.connect("Main_harness_78", nodeName6);
		dw.createSubgraph("finding index of\\nNode recursively\\non Node", "LinkedList of nodes", 6);

		String nodeName7 = dw.createNode(ll.getClass().getSimpleName(), "recursiveIndexOfFrom", 101, false);
		dw.connect("Main_harness_78", nodeName7);
		dw.createSubgraph("finding index of\\nNode recursively", "LinkedList of nodes", 7);

		String nodeName8 = dw.createNode(ll.getClass().getSimpleName(), "iterativePrint", 110, true);
		dw.connect("Main_harness_78", nodeName8);
		dw.createSubgraph("printing LinkedList", "LinkedList of nodes", 8);

		String nodeName9 = dw.createNode("Node", "recursivePrint", 36, false);
		dw.connect("Main_harness_78", nodeName9);
		dw.createSubgraph("printing elements\\on Node recursively", "LinkedList of nodes", 9);

		String nodeName10 = dw.createNode(ll.getClass().getSimpleName(), "recursivePrintFrom", 138, false);
		dw.connect("Main_harness_78", nodeName10);
		dw.createSubgraph("recursivelyprinting//nLinkedList", "LinkedList of nodes", 10);

		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/list/linked/basic");
		
	}

	public void visit(ch.usi.inf.sape.algoprof.example.list.linked.basic.Main m) {
		dw = new DotWriter();	
		String name = dw.createNode(m.getClass().getSimpleName(), "harness", 78, true);
		dw.createSubgraph("Harness", "nodes size", 0);
		
	}

	public void visit(ch.usi.inf.sape.algoprof.example.list.linked.basic.Node n) {
		// TODO Auto-generated method stub
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.list.linked.generic.LinkedList ll) {
		String nodeName1 = dw.createNode("Main", "testForSize", 109, true);
		dw.connect("Main_harness_81", nodeName1);
		dw.createSubgraph("appending elements\\nto List", "LinkedList of T", 1);
		
		String nodeName2 = dw.createNode(ll.getClass().getSimpleName(), "iterativeLength", 36, true);
		dw.connect("Main_harness_81", nodeName2);
		dw.createSubgraph("counting length\\nof LinkedList", "LinkedList of T", 2);
		
		String nodeName3 = dw.createNode("Node", "recursiveLength", 27, false);
		dw.connect("Main_harness_81", nodeName3);
		dw.createSubgraph("counting length\\non Node", "LinkedList of T", 3);	
		
		String nodeName4 = dw.createNode(ll.getClass().getSimpleName(), "recursiveLengthFrom", 62, false);
		dw.connect("Main_harness_81", nodeName4);
		dw.createSubgraph("counting length\\nof LinkedList", "LinkedList of T", 4);
		
		String nodeName5 = dw.createNode(ll.getClass().getSimpleName(), "iterativeIndexOf", 70, true);
		dw.connect("Main_harness_81", nodeName5);
		dw.createSubgraph("finding index of\\nNode, iteratively", "LinkedList of T", 5);
		
		String nodeName6 = dw.createNode("Node", "recursiveIndexOf", 48, false);
		dw.connect("Main_harness_81", nodeName6);
		dw.createSubgraph("finding index of\\nNode recursively\\non Node", "LinkedList of T", 6);

		String nodeName7 = dw.createNode(ll.getClass().getSimpleName(), "recursiveIndexOfFrom", 102, false);
		dw.connect("Main_harness_81", nodeName7);
		dw.createSubgraph("finding index of\\nNode recursively", "LinkedList of T", 7);

		String nodeName8 = dw.createNode(ll.getClass().getSimpleName(), "iterativePrint", 111, true);
		dw.connect("Main_harness_81", nodeName8);
		dw.createSubgraph("printing LinkedList", "LinkedList of T", 8);

		String nodeName9 = dw.createNode("Node", "recursivePrint", 36, false);
		dw.connect("Main_harness_81", nodeName9);
		dw.createSubgraph("printing elements\\on Node recursively", "LinkedList of T", 9);

		String nodeName10 = dw.createNode(ll.getClass().getSimpleName(), "recursivePrintFrom", 139, false);
		dw.connect("Main_harness_81", nodeName10);
		dw.createSubgraph("recursivelyprinting//nLinkedList", "LinkedList of T", 10);

		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/list/linked/generic");
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.list.linked.generic.Main m) {
		dw = new DotWriter();	
		String name = dw.createNode(m.getClass().getSimpleName(), "harness", 81, true);
		dw.createSubgraph("Harness", "nodes size", 0);
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.list.linked.generic.Node<?> n) {
		// TODO Auto-generated method stub
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.list.linked.inheritance.LinkedList ll) {
		String nodeName1 = dw.createNode("Main", "testForSize", 107, true);
		dw.connect("Main_harness_79", nodeName1);
		dw.createSubgraph("appending elements\\nto List", "LinkedList of interface", 1);
		
		String nodeName2 = dw.createNode(ll.getClass().getSimpleName(), "iterativeLength", 43, true);
		dw.connect("Main_harness_79", nodeName2);
		dw.createSubgraph("counting length\\nof LinkedList", "LinkedList of interface", 2);
		
		String nodeName3 = dw.createNode("Node", "recursiveLength", 27, false);
		dw.connect("Main_harness_79", nodeName3);
		dw.createSubgraph("counting length\\non Node", "LinkedList of interface", 3);	
		
		String nodeName4 = dw.createNode(ll.getClass().getSimpleName(), "recursiveLengthFrom", 69, false);
		dw.connect("Main_harness_79", nodeName4);
		dw.createSubgraph("counting length\\nof LinkedList", "LinkedList of interface", 4);
		
		String nodeName5 = dw.createNode(ll.getClass().getSimpleName(), "iterativeIndexOf", 79, true);
		dw.connect("Main_harness_79", nodeName5);
		dw.createSubgraph("finding index of\\nNode, iteratively", "LinkedList of interface", 5);
		
		String nodeName6 = dw.createNode("Node", "recursiveIndexOf", 48, false);
		dw.connect("Main_harness_79", nodeName6);
		dw.createSubgraph("finding index of\\nNode recursively\\non Node", "LinkedList of interface", 6);

		String nodeName7 = dw.createNode(ll.getClass().getSimpleName(), "recursiveIndexOfFrom", 109, false);
		dw.connect("Main_harness_79", nodeName7);
		dw.createSubgraph("finding index of\\nNode recursively", "LinkedList of interface", 7);

		String nodeName8 = dw.createNode(ll.getClass().getSimpleName(), "iterativePrint", 118, true);
		dw.connect("Main_harness_79", nodeName8);
		dw.createSubgraph("printing LinkedList", "LinkedList of interface", 8);

		String nodeName9 = dw.createNode("Node", "recursivePrint", 36, false);
		dw.connect("Main_harness_79", nodeName9);
		dw.createSubgraph("printing elements\\on Node recursively", "LinkedList of interface", 9);

		String nodeName10 = dw.createNode(ll.getClass().getSimpleName(), "recursivePrintFrom", 146, false);
		dw.connect("Main_harness_79", nodeName10);
		dw.createSubgraph("recursivelyprinting//nLinkedList", "LinkedList of interface", 10);

		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/list/linked/inheritance");
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.list.linked.inheritance.Main m) {
		dw = new DotWriter();	
		String name = dw.createNode(m.getClass().getSimpleName(), "harness", 79, true);
		dw.createSubgraph("Harness", "nodes size", 0);
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.list.linked.inheritance.Node n) {
		// TODO Auto-generated method stub
		
	}

	public void visit(PingNode ping) {
		// TODO Auto-generated method stub
		
	}

	public void visit(PongNode pong) {
		// TODO Auto-generated method stub
		
	}

	public void visit(List l) {
		String nodeName1 = dw.createNode("Main", "construct", 110, true);
		dw.connect("Main_measure_72", nodeName1);
		dw.createSubgraph("constructing List\\nof recursive Node\\nin sorted order", "List is Linked", 1);
		
		String nodeName2 = dw.createNode("Main", "constructReversed", 118, true);
		dw.connect("Main_measure_72", nodeName2);
		dw.createSubgraph("constructing List\\nof recursive Node\\nin reversed order", "List is Linked", 2);
		
		String nodeName3 = dw.createNode("Main", "constructRandom", 127, true);
		dw.connect("Main_measure_72", nodeName3);
		dw.createSubgraph("constructing List\\nof recursive Node\\nin random order", "List is Linked", 3);
		
		String nodeName4 = dw.createNode(l.getClass().getSimpleName(), "sort", 55, true);
		String nodeName5 = dw.createNode(l.getClass().getSimpleName(), "sort", 63, true);
		dw.connect("Main_measure_72", nodeName4);
		dw.connect(nodeName4, nodeName5);
		dw.createSubgraph("sorting List", "List is Linked", 4);

		
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/sort/insertion");
		
		
	}

	public void visit(ch.usi.inf.sape.algoprof.example.sort.insertion.Main m) {
		dw = new DotWriter();	
		String name1 = dw.createNode(m.getClass().getSimpleName(), "measure", 70, true);
		String name2 = dw.createNode(m.getClass().getSimpleName(), "measure", 72, true);
		dw.connect(name1, name2);
		dw.createSubgraph("Harness", "List size", 0);
		
		
	}

	public void visit(ch.usi.inf.sape.algoprof.example.sort.insertion.Node n) {
		// TODO Auto-generated method stub
		
	}

	public void visit(BinaryTree bt) {
		String nodeName1 = dw.createNode(bt.getClass().getSimpleName(), "addDescendants", 21, false);
		dw.connect("Main_harness_49", nodeName1);
		dw.createSubgraph("appending elements\\nto BinaryTree", "BinaryTree as []int", 1);
		
		String nodeName2 = dw.createNode(bt.getClass().getSimpleName(), "recursivePrintFrom", 67, false);
		dw.connect("Main_harness_49", nodeName2);
		dw.createSubgraph("recursive tree\\nelements printing", "BinaryTree as int[]", 2);
		
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/tree/array/perfect/binary");
		
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.tree.array.perfect.binary.Main m) {
		dw = new DotWriter();	
		String name = dw.createNode(m.getClass().getSimpleName(), "harness", 49, true);
		dw.createSubgraph("Harness", "height size", 0);
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.tree.linked.perfect.binary.basic.BinaryTree bt) {
		String nodeName1 = dw.createNode(bt.getClass().getSimpleName(), "addDescendants", 20, false);
		dw.connect("Main_harness_52", nodeName1);
		dw.createSubgraph("appending elements\\nto BinaryTree", "BinaryTree as Node", 1);
		
		String nodeName2 = dw.createNode(bt.getClass().getSimpleName(), "recursivePrintFrom", 55, false);
		dw.connect("Main_harness_52", nodeName2);
		dw.createSubgraph("recursive tree\\nelements printing", "BinaryTree as Node", 2);
		
		String nodeName3 = dw.createNode("Node", "print", 53, false);
		dw.connect("Main_harness_52", nodeName3);
		dw.createSubgraph("recursive Node\\nelements printing", "BinaryTree as Node", 3);
		
		
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/tree/linked/perfect/binary/basic");
		
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.tree.linked.perfect.binary.basic.Main m) {
		dw = new DotWriter();	
		String name = dw.createNode(m.getClass().getSimpleName(), "harness", 52, true);
		dw.createSubgraph("Harness", "height size", 0);
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.tree.linked.perfect.binary.basic.Node n) {
		// TODO Auto-generated method stub
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.tree.linked.perfect.binary.basic.bidi.BinaryTree bt) {
		String nodeName1 = dw.createNode(bt.getClass().getSimpleName(), "addDescendants", 20, false);
		dw.connect("Main_harness_51", nodeName1);
		dw.createSubgraph("appending elements\\nto BinaryTree", "BinaryTree as Node", 1);
		
		String nodeName2 = dw.createNode(bt.getClass().getSimpleName(), "recursivePrintFrom", 55, false);
		dw.connect("Main_harness_51", nodeName2);
		dw.createSubgraph("recursive tree\\nelements printing", "BinaryTree as Node", 2);
		
		String nodeName3 = dw.createNode("Node", "print", 53, false);
		dw.connect("Main_harness_51", nodeName3);
		dw.createSubgraph("recursive Node\\nelements printing", "BinaryTree as Node", 3);
		
		
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/tree/linked/perfect/binary/basic/bidi");
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.tree.linked.perfect.binary.basic.bidi.Main m) {
		dw = new DotWriter();	
		String name = dw.createNode(m.getClass().getSimpleName(), "harness", 51, true);
		dw.createSubgraph("Harness", "height size", 0);
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.tree.linked.perfect.binary.basic.bidi.Node n) {
		// TODO Auto-generated method stub
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.tree.linked.perfect.nary.basic.Main m) {
		dw = new DotWriter();	
		String name = dw.createNode(m.getClass().getSimpleName(), "harness", 54, true);
		String name2 = dw.createNode(m.getClass().getSimpleName(), "harness", 55, true);
		dw.connect(name, name2);
		dw.createSubgraph("Harness", "height size", 0);
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.tree.linked.perfect.nary.basic.Node n) {
		// TODO Auto-generated method stub
		
	}

	public void visit(NaryTree nt) {
		String nodeName1 = dw.createNode(nt.getClass().getSimpleName(), "addDescendants", 20, false);
		String nodeName11 = dw.createNode(nt.getClass().getSimpleName(), "addDescendants", 25, true);
		dw.connect("Main_harness_55", nodeName1);
		dw.connect(nodeName1, nodeName11);
		dw.createSubgraph("appending elements\\nto BinaryTree", "NaryTree as Node", 1);
		
		String nodeName2 = dw.createNode(nt.getClass().getSimpleName(), "recursivePrintFrom", 55, false);
		String nodeName22 = dw.createNode(nt.getClass().getSimpleName(), "recursivePrintFrom", 59, true);
		dw.connect(nodeName2, nodeName22);
		dw.connect("Main_harness_55", nodeName2);
		dw.createSubgraph("recursive tree\\nelements printing", "NaryTree as Node", 2);
		
		String nodeName3 = dw.createNode("Node", "print", 50, false);
		String nodeName33 = dw.createNode(nt.getClass().getSimpleName(), "print", 52, true);
		dw.connect(nodeName3, nodeName33);
		dw.connect("Main_harness_55", nodeName3);
		dw.createSubgraph("recursive Node\\nelements printing", "NaryTree as Node", 3);
		
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/tree/linked/perfect/nary/basic");
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.tree.linked.perfect.nary.basic.bidi.Main m) {
		dw = new DotWriter();	
		String name = dw.createNode(m.getClass().getSimpleName(), "harness", 54, true);
		String name2 = dw.createNode(m.getClass().getSimpleName(), "harness", 55, true);
		dw.connect(name, name2);
		dw.createSubgraph("Harness", "height size", 0);
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.tree.linked.perfect.nary.basic.bidi.NaryTree nt) {
		String nodeName1 = dw.createNode(nt.getClass().getSimpleName(), "addDescendants", 20, false);
		String nodeName11 = dw.createNode(nt.getClass().getSimpleName(), "addDescendats", 24, true);
		dw.connect(nodeName1, nodeName11);
		dw.connect("Main_harness_55", nodeName1);
		dw.createSubgraph("appending elements\\nto BinaryTree", "NaryTree as Node", 1);
		
		String nodeName2 = dw.createNode(nt.getClass().getSimpleName(), "recursivePrintFrom", 55, false);
		String nodeName22 = dw.createNode(nt.getClass().getSimpleName(), "recursivePrintFrom", 59, true);
		dw.connect(nodeName2, nodeName22);

		dw.connect("Main_harness_55", nodeName2);
		dw.createSubgraph("recursive tree\\nelements printing", "NaryTree as Node", 2);
		
		String nodeName3 = dw.createNode("Node", "print", 50, false);
		String nodeName33 = dw.createNode(nt.getClass().getSimpleName(), "print", 52, true);
		dw.connect(nodeName3, nodeName33);

		dw.connect("Main_harness_55", nodeName3);
		dw.createSubgraph("recursive Node\\nelements printing", "NaryTree as Node", 3);
		
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/tree/linked/perfect/nary/basic/bidi");
		
	}

	public void visit(
			ch.usi.inf.sape.algoprof.example.tree.linked.perfect.nary.basic.bidi.Node n) {
		// TODO Auto-generated method stub
		
	}

	

	public void visit(InsertionSortAlgorithm is) {
		dw = new DotWriter();
		String nodeName0 = dw.createNode(is.getClass().getSimpleName(), "harness", 47, true);
		String nodeName1 = dw.createNode(is.getClass().getSimpleName(), "harness", 48, true);
		dw.connect(nodeName0, nodeName1);
		dw.createSubgraph("simple harness, 10000*3 times", "index i and j", 1);
		
		String nodeName2 = dw.createNode(is.getClass().getSimpleName(), "fillArray", 23, true);
		dw.connect(nodeName1, nodeName2);
		dw.createSubgraph("constructing int[]\\by random numbers", "int[]", 2);
		String nodeName3 = dw.createNode(is.getClass().getSimpleName(), "sort", 72, true);
		String nodeName4 = dw.createNode(is.getClass().getSimpleName(), "sort", 76, true);

		dw.connect(nodeName1, nodeName3);
		dw.connect(nodeName3, nodeName4);
		dw.createSubgraph("sorting int[]", "int[]", 3);

		
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/sort/insertion2");
		
	}

	

	public void visit(ch.usi.inf.sape.algoprof.example.sort.insertion3.Main is) {
		dw = new DotWriter();
		String nodeName0 = dw.createNode(is.getClass().getSimpleName(), "harness", 47, true);
		String nodeName1 = dw.createNode(is.getClass().getSimpleName(), "harness", 48, true);
		dw.connect(nodeName0, nodeName1);
		dw.createSubgraph("simple harness, 10000*3 times", "index i and j", 1);
		
		String nodeName2 = dw.createNode(is.getClass().getSimpleName(), "fillArray", 23, false);
		dw.connect(nodeName1, nodeName2);
		dw.createSubgraph("constructing int[]\\by random numbers", "int[]", 2);
		
		String nodeName3 = dw.createNode("Cons", "sort", 12, false);
		String nodeName4 = dw.createNode("Cons", "insert", 16, false);	
		dw.connect(nodeName1, nodeName3);
		dw.connect(nodeName3, nodeName3);
		dw.connect(nodeName3, nodeName4);
		dw.connect(nodeName4, nodeName4);
		dw.createSubgraph("sorting int[]", "int[]", 3);
		
				
		dw.writeToDot(System.getProperty("user.dir") + "/src/ch/usi/inf/sape/algoprof/example/sort/insertion3");
	}

	
	

}
