package ch.usi.inf.sape.algoprof.statistics;

public interface AlgorithmVisitor {
	
	void visit(ch.usi.inf.sape.algoprof.example.array.multidimensional.IntegerArray ia);
	void visit(ch.usi.inf.sape.algoprof.example.array.multidimensional.Main m);
	
	void visit(ch.usi.inf.sape.algoprof.example.array.multidimensional.local.IntegerArray ia);
	void visit(ch.usi.inf.sape.algoprof.example.array.multidimensional.local.Main m);
	
	void visit(ch.usi.inf.sape.algoprof.example.graph.directed.adjacencymatrix.basic.Graph g);
	void visit(ch.usi.inf.sape.algoprof.example.graph.directed.adjacencymatrix.basic.Main m);
	
	void visit(ch.usi.inf.sape.algoprof.example.graph.directed.linked.basic.Main m);
	void visit(ch.usi.inf.sape.algoprof.example.graph.directed.linked.basic.Node n);
	void visit(ch.usi.inf.sape.algoprof.example.graph.directed.linked.basic.Graph g);

	void visit(ch.usi.inf.sape.algoprof.example.graph.directed.linked.basic.bidi.Graph g);
	void visit(ch.usi.inf.sape.algoprof.example.graph.directed.linked.basic.bidi.Main m);
	void visit(ch.usi.inf.sape.algoprof.example.graph.directed.linked.basic.bidi.Node n);
	
	void visit(ch.usi.inf.sape.algoprof.example.graph.undirected.linked.basic.Graph g);
	void visit(ch.usi.inf.sape.algoprof.example.graph.undirected.linked.basic.Main m);
	void visit(ch.usi.inf.sape.algoprof.example.graph.undirected.linked.basic.Node n);
	
	void visit(ch.usi.inf.sape.algoprof.example.list.array.doubling.basic.ArrayList al);
	void visit(ch.usi.inf.sape.algoprof.example.list.array.doubling.basic.Main m);
	
	void visit(ch.usi.inf.sape.algoprof.example.list.array.naive.basic.ArrayList al);
	void visit(ch.usi.inf.sape.algoprof.example.list.array.naive.basic.Main m);
	
	void visit(ch.usi.inf.sape.algoprof.example.list.array.naive.generic.ArrayList<?> al);
	void visit(ch.usi.inf.sape.algoprof.example.list.array.naive.generic.Main m);
	
	void visit(ch.usi.inf.sape.algoprof.example.list.array.naive.inheritance2.ArrayList al);
	void visit(ch.usi.inf.sape.algoprof.example.list.array.naive.inheritance2.PingValue ping);
	void visit(ch.usi.inf.sape.algoprof.example.list.array.naive.inheritance2.PongValue pong);
	void visit(ch.usi.inf.sape.algoprof.example.list.array.naive.inheritance2.Main m);
	
	void visit(ch.usi.inf.sape.algoprof.example.list.linked.basic.LinkedList ll);
	void visit(ch.usi.inf.sape.algoprof.example.list.linked.basic.Main m);
	void visit(ch.usi.inf.sape.algoprof.example.list.linked.basic.Node n);

	void visit(ch.usi.inf.sape.algoprof.example.list.linked.generic.LinkedList ll);
	void visit(ch.usi.inf.sape.algoprof.example.list.linked.generic.Main m);
	void visit(ch.usi.inf.sape.algoprof.example.list.linked.generic.Node<?> n);
	
	void visit(ch.usi.inf.sape.algoprof.example.list.linked.inheritance.LinkedList ll);
	void visit(ch.usi.inf.sape.algoprof.example.list.linked.inheritance.Main m);
	void visit(ch.usi.inf.sape.algoprof.example.list.linked.inheritance.Node n);
	void visit(ch.usi.inf.sape.algoprof.example.list.linked.inheritance.PingNode ping);
	void visit(ch.usi.inf.sape.algoprof.example.list.linked.inheritance.PongNode pong);
	
	void visit(ch.usi.inf.sape.algoprof.example.sort.insertion.List l);
	void visit(ch.usi.inf.sape.algoprof.example.sort.insertion.Main m);
	void visit(ch.usi.inf.sape.algoprof.example.sort.insertion.Node n);
	
	void visit(ch.usi.inf.sape.algoprof.example.tree.array.perfect.binary.BinaryTree bt);
	void visit(ch.usi.inf.sape.algoprof.example.tree.array.perfect.binary.Main m);
	
	void visit(ch.usi.inf.sape.algoprof.example.tree.linked.perfect.binary.basic.BinaryTree bt);
	void visit(ch.usi.inf.sape.algoprof.example.tree.linked.perfect.binary.basic.Main m);
	void visit(ch.usi.inf.sape.algoprof.example.tree.linked.perfect.binary.basic.Node n);
	
	void visit(ch.usi.inf.sape.algoprof.example.tree.linked.perfect.binary.basic.bidi.BinaryTree bt);
	void visit(ch.usi.inf.sape.algoprof.example.tree.linked.perfect.binary.basic.bidi.Main m);
	void visit(ch.usi.inf.sape.algoprof.example.tree.linked.perfect.binary.basic.bidi.Node n);
	
	void visit(ch.usi.inf.sape.algoprof.example.tree.linked.perfect.nary.basic.Main m);
	void visit(ch.usi.inf.sape.algoprof.example.tree.linked.perfect.nary.basic.Node n);
	void visit(ch.usi.inf.sape.algoprof.example.tree.linked.perfect.nary.basic.NaryTree nt);

	void visit(ch.usi.inf.sape.algoprof.example.tree.linked.perfect.nary.basic.bidi.Main m);
	void visit(ch.usi.inf.sape.algoprof.example.tree.linked.perfect.nary.basic.bidi.NaryTree nt);
	void visit(ch.usi.inf.sape.algoprof.example.tree.linked.perfect.nary.basic.bidi.Node n);
	
	
	void visit(ch.usi.inf.sape.algoprof.example.sort.insertion2.InsertionSortAlgorithm is);
	
	
	void visit(ch.usi.inf.sape.algoprof.example.sort.insertion3.Main is);
	
}