package ch.usi.inf.sape.algoprof.statistics;

import java.util.Map;


public class Script {
	
	private String text;

	
	/*pdf("measurements.pdf", width=8, height=8)
	t = read.table("measurements.txt", header=T)
	plot(t)
	x=1:1000
	lines(x, 0.25*x*x, col="red")
	legend("topleft", c("Manually fitted: Comparisons=0.25*Size^2","Measured"), col=c("red","black"), pch=20, bg="white")
	dev.off()
	*/


	
	public Script(final String costFunction, final String txtFileName, final String path, final String xlab) {
		
	
		text = "setwd(\""+  System.getProperty("user.dir") + path + "\")" + "\n" +
		 "pdf(file=\"" + txtFileName + "" + ".pdf" + "\", width=8, height=8, paper=\"special\")"  + "\n" + 
		 "t = read.table(\"" + txtFileName +".txt\",header=T)" + "\n" +
		 "par(mar=c(5,5,1,0.5))" + "\n" + 
		 "plot(t, xlab=\""+ xlab + "\")" + "\n" +
		 "last=max(t$Size)\n" +
		 "size=0:last\n" +
		 "lines(size," + costFunction + ", col=\"red\")\n" +
		 "legend(\"topleft\", c(\"Manually fitted: Steps=" + costFunction + "\", \"Measured\"), col=c(\"red\",\"black\"), pch=20, bg=\"white\")" + "\n" +
		 "dev.off();";
		
	}

	
	@Override
	public String toString() {
		return text;
	}
}
