package ch.unisi.inf.sp.cfg;

import java.util.ArrayList;
import java.util.List;

public class Block {
	private final List<InstructionData> instrs = new ArrayList<InstructionData>();
	private List<Edge> edges = new ArrayList<Edge>();
	private int index;
	public boolean visited = false;
	
	public void addInstr(InstructionData instr) {
		instrs.add(instr);
	}
	
	public void setEdges(List<Edge> edges) {
		this.edges = edges;
	}
	
	public List<Edge> getEdges() {
		return edges;
	}
	
	public List<InstructionData> getInstrs() {
		return instrs;
	}
	
	public boolean isEmpty() {
		for (InstructionData data: instrs) {
			if (data.getName() != null) {
				return false;
			}
		}
		return true;
	}
	
	public String getInstructions(String suffix) {
		String name = getName(suffix);
		StringBuffer buff = new StringBuffer();
		buff.append(name + suffix + "[shape=record,  label = \"" );
		buff.append("(B" + getInstrs().get(0).i + ")|").append('{');
		
		boolean isFirst = true;
		for (InstructionData data: getInstrs()) {
			if (data.getName() != null) {
				if (isFirst) {
					isFirst = false;
				} else {
					buff.append("|");
				}
				buff.append(data.i + ": " + data.getName());
			}
		}
		buff.append("}\"]\n");
		return buff.toString();
	}
	
	public String getEdgesAsString(String suffix) {
		String name = getName(suffix);
		StringBuffer buff = new StringBuffer();
		for (Edge edge: getEdges()) {
			buff.append(edge.draw(name, suffix));
		}
		return buff.toString();
	}

	private String getName(String suffix) {
		return "b" + instrs.get(0).i;
	}
	
	public int getBlockNumber() {
		if (index == - 1) {
			return -1;
		} else {
			if (instrs.get(0)==null) {
				System.out.println("alarm");
			}
			return instrs.get(0).i;
		}
	}
	
	public void setBlockIndex (int i) {
		index = i;
	}
	
	public int getBlockIndex () {
		return index;
	}
}
