package ch.unisi.inf.sp.cfg;

public class ExceptionData implements Comparable<ExceptionData>{
	private final int start;
	private final int end;
	private final int handler;
	private boolean isFinally;

	public ExceptionData(int start, int end, int handler, String type) {
		this.start = start;
		this.end = end;
		this.handler = handler;
		this.isFinally = (type == null); 
	}
	
	public boolean isInside(int x) {
		return (x >= start) && (x <= end);
	}

	public boolean isFinally() {
		return isFinally;
	}
	
	public int getHandler() {
		return handler;
	}
	
	public String toString() {
		return "start = " + start + ", end = " + end + ", handler = " + handler;
	}

	public int compareTo(ExceptionData o) {
		if (this.start == o.start) {
			return 0;
		} else if (this.start > o.start) {
			return -1;
		} else {
			return 1;
		}
	}
}
