package ch.unisi.inf.sp.cfg;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class Exceptions {
	private final List<ExceptionData> tcfBlocks = new ArrayList<ExceptionData>();
	
	public void add(ExceptionData excData) {
		tcfBlocks.add(excData);
	}
	
	public Pair<List<Integer>, Boolean> getPossibleJumps(int i) {
		Pair<List<ExceptionData>, Boolean> pair = getPossibleJumpsAsExcList(i);
		List<ExceptionData> excList = pair.t;
		List<Integer> result = new ArrayList<Integer>();
		for (ExceptionData data: excList) {
			result.add(data.getHandler());
		}
		return new Pair<List<Integer>, Boolean>(result, pair.v);
	}
	
	private Pair<List<ExceptionData>, Boolean> getPossibleJumpsAsExcList(int i) {
		List<ExceptionData> insiders = new ArrayList<ExceptionData>();
		for (ExceptionData data: tcfBlocks) {
			if (data.isInside(i)) {
				insiders.add(data);
			}
		}
		Collections.sort(insiders);
		for (int k = 0; k < insiders.size(); k++) {
			if (insiders.get(k).isFinally()) {
				return new Pair<List<ExceptionData>, Boolean>(insiders.subList(0, k+1), true);
			}
		}
		return new Pair<List<ExceptionData>, Boolean>(insiders, false);
	}
}
