package ch.unisi.inf.sp.cfg;



import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentMap;

import org.objectweb.asm.tree.AbstractInsnNode;

import usi.instrumentation.OpcodeReader;

public class Loop {

	public AbstractInsnNode header;
	public List<AbstractInsnNode> outTails;
	public List<AbstractInsnNode> inTails;
	public List<AbstractInsnNode> instructionsPointingToHeader;
	public ConcurrentMap<AbstractInsnNode, InstructionPointer> instructionsPointingOutOfTheLoop; //either return or exception or break
	public int[] numbers = new int[2];
	
	//instr pointing to tales
	
	public Loop(AbstractInsnNode header, List<AbstractInsnNode> outTails, List<AbstractInsnNode> inTails, List<AbstractInsnNode> instructionsPointingToHeader, ConcurrentMap<AbstractInsnNode, InstructionPointer> instructionsPointingOutOfTheLoop) {
		this.header = header;
		this.outTails = outTails;
		this.inTails = inTails;
		this.instructionsPointingToHeader = instructionsPointingToHeader;
		this.instructionsPointingOutOfTheLoop = instructionsPointingOutOfTheLoop;
	}
	
	@Override
	public String toString() {
		String str = "";
		str = "Loop" + numbers[0] + "-" + numbers[1];
		str = str + "\n" + "with intails ";
		for (AbstractInsnNode node: inTails) {
			str = str + "\t" + OpcodeReader.giveName(node);
		}
		str = str + "\n" + "with outtails ";
		for (AbstractInsnNode node: outTails) {
			str = str + "\t" + OpcodeReader.giveName(node);
		}
		
		return str;
	}
	
}
