package ch.unisi.inf.sp.tree;

import java.util.HashMap;
import java.util.Map;

import usi.instrumentation.stack.Node;

public class Snode<T> extends Node {
	
	public enum Kind {
		LOOP, RECURSIVE, NORMAL }
	
	private Kind kind;
	private Map<Node<T>, Integer> edges;
	
	public int numberOfLoops;
	
	public Snode(String str, Kind kind, int numberOfLoops) {
		super(str);
		this.kind = kind;
		edges = new HashMap<Node<T>, Integer>();
		this.numberOfLoops = numberOfLoops;
	}
	
	
	public Kind getKind() {
	
		return kind;
	}
	
	public void setKind(Kind kind) {
		this.kind = kind;
	}

	public void setEdge(int opcode, Node<T> child) {
		edges.put(child, opcode);
	}
	
	public int getEdge(Node<T> child) {
		return edges.get(child);
	}
}
