package ch.unisi.inf.sp.type;


/**
 * Represents a primitive type.

 * @author Matthias.Hauswirth@usi.ch
 */
public enum PrimitiveType implements Type {

	BYTE("b", "byte"), 
	SHORT("s", "short"), 
	CHAR("c", "char"), 
	INT("i", "int"), 
	LONG("j", "long"), 
	FLOAT("f", "float"), 
	DOUBLE("d", "double"), 
	BOOLEAN("z", "boolean"), 
	VOID("v", "void");
	
	private final String internalName;
	private final String simpleName;
	
	
	private PrimitiveType(final String internalName, final String simpleName) {
		this.internalName = internalName;
		this.simpleName = simpleName;
	}
	
	public String getInternalName() {
		return internalName;
	}
	
	public boolean isResolved() {
		return true;
	}
	
	public String getSimpleName() {
		return simpleName;
	}
	
}
