package ch.unisi.inf.sp.type;


public class StatisticsDumper {

	public void dump(final ClassHierarchy nameSpace) {
		int types = 0;
		int resolvedTypes = 0;
		int classTypes = 0;
		int interfaces = 0;
		int abstractClasses = 0;
		int concreteClasses = 0;
		int finalClasses = 0;
		for (final Type type : nameSpace.getTypes()) {
			types++;
			if (type.isResolved()) {
				resolvedTypes++;
				if (type instanceof ClassType) {
					final ClassType classType = (ClassType)type;
					classTypes++;
					if (classType.isInterface()) {
						interfaces++;
					} else if (classType.isAbstract()) {
						abstractClasses++;
					} else if (classType.isFinal()) {
						finalClasses++;
					} else {
						concreteClasses++;
					}
				}
			}
		}
		System.out.println("Types:\t"+types);
		System.out.println(" unresolved:\t"+(types-resolvedTypes));
		System.out.println(" resolved:\t"+resolvedTypes);
		System.out.println("  ClassTypes:\t"+classTypes);
		System.out.println("   interface:\t"+interfaces);
		System.out.println("   abstract:\t"+abstractClasses);
		System.out.println("   concrete:\t"+concreteClasses);
		System.out.println("   final:\t"+finalClasses);
	}
}
