package ch.usi.inf.sape.graph.algorithms;

import java.util.ArrayList;
import java.util.List;

import ch.usi.inf.sape.graph.Node;


/**
 * A strongly connected component in an underlying graph.
 * 
 * @author Matthias.Hauswirth@usi.ch
 */
public final class StronglyConnectedComponent {

	private final ArrayList<Node> nodes;
	
	
	public StronglyConnectedComponent() {
		nodes = new ArrayList<Node>();
	}
	
	public void addNode(final Node n) {
		nodes.add(n);
	}
	
	public List<Node> getNodes() {
		return nodes;
	}
	
}
