package ch.usi.inf.sape.graph.dot;

import ch.usi.inf.sape.graph.FlowGraph;
import ch.usi.inf.sape.graph.Node;
import ch.usi.inf.sape.graph.loop.LoopForest2;


/**
 * Renders nodes that represent loop headers in filled red.
 * 
 * @author Matthias.Hauswirth@usi.ch
 */
public class LoopNestingNodeAttributeStringProvider2 implements NodeAttributeStringProvider {

	private final LoopForest2 forest;
	
	public LoopNestingNodeAttributeStringProvider2(final LoopForest2 forest) {
		this.forest = forest;
	}
	
	public String getAttributeString(FlowGraph graph, Node node) {
		final String bold = forest.isHeader(node)?"style=filled,fillcolor=red,":"";

		if (node==graph.getEntryNode()) {
			return "["+bold+"shape=rectangle,label=\""+node.toString()+"\"]";
		} else {
			return "["+bold+"label=\""+node.toString()+"\"]";
		}
	}
	
}
