package ch.usi.inf.sape.graph.example;

import ch.unisi.inf.sp.tree.Snode.Kind;
import ch.usi.inf.sape.graph.Node;

public class FullNode extends Node {
	
	
	/*
	- number of polymorphic recursive cycles (recursive cycles that involve at least one INVOKE_INTERFACE or INVOKE_VIRTUAL)
	- number of constructive recursive cycles (recursive cycles that involve at least one constructor) + loop constractive including transitive
	- number of in-package recursive cycles (recursive cycles that do NOT cross package-boundaries*)
	- number of in-class recursive cycles (recursive cycles that do NOT cross class-boundaries*)
	- number of header-only recursive cycles (recursive cycles where the header consists of the entire body)
	- number of single-header recursive cycles (recursive cycles where the header consists of a single node)
	- number of multi-header recursive cycles (recursive cycles where the header consists of multiple nodes)
	- recursive cycle body size distribution (number of a cycle's body nodes)
	- recursive cycle header size distribution (number of a cycle's header nodes)
	- nesting depth information:
	 - number of loop per method distribution
	 - number of top/second/third/...-level recursive cycles (I expect to see mostly top) dfs on forrest

	*/
	
	private String label;
	private Kind kind; 
	public boolean Constructive_transitive = false;
	public int numberOfLoops;
	
	public FullNode(final String label, Kind kind, int numberOfLoops) {
		this.label = label;
		this.kind = kind;
		this.numberOfLoops = numberOfLoops;
	}
	
	public String getLabel() {
		return label;
	}
	
	public void setLabel(final String label) {
		this.label = label;
	}
	
	@Override
	public String toString() {
		return label;
	}
	
	
	public Kind getKind() {
		return kind;
	}
	
	public void setKind (Kind kind) {
		this.kind = kind;
	}
	

}
