package org.objectweb.asm.util;

import org.objectweb.asm.ClassAdapter;
import org.objectweb.asm.ClassVisitor;
import org.objectweb.asm.FieldVisitor;
import org.objectweb.asm.MethodAdapter;
import org.objectweb.asm.MethodVisitor;


public class AddListenerCallTimerClassAdapter extends ClassAdapter {
	  
	  private int fAcc = 0;
	  private String fName = "";
	  private String fDesc = "";
	  private boolean isFieldPresent = false;
	  
	  public AddListenerCallTimerClassAdapter (ClassVisitor cv) {
		  super (cv);
	  }
	  
	  
	  public AddListenerCallTimerClassAdapter(ClassVisitor cv, int fAcc, String fName, String fDesc) {
	    super(cv);
	    this.fAcc = fAcc;
	    this.fName = fName;
	    this.fDesc = fDesc;
	  }

	  /*	 
	  @Override
	  public FieldVisitor visitField(int access, String name, String desc, String signature, Object value) {
		  if (name.equals(fName)) {
			  isFieldPresent = true;
		  }
		  return cv.visitField(access, name, desc, signature, value);
	  }
	  
	  @Override
	  public void visitEnd() {
		  if (!isFieldPresent) {
			  FieldVisitor fv = cv.visitField(fAcc, fName, fDesc, null, null);
			  if (fv != null) {
				  fv.visitEnd();
			  }
		  }
		  cv.visitEnd();
	  }
	  
	  */
	  @Override
	  public void visit(int version, int access, String name, String signature, String superName, String [] interfaces) {
		  cv.visit(version, access, name, signature, superName, interfaces);
//		  System.out.println(name + " " + superName + " " + interfaces [0] + " " + signature);
	  }
	  
	  @Override
	  public MethodVisitor visitMethod(int access, String name, String desc, String signature, String[] exceptions) {	 
		  MethodVisitor mv = cv.visitMethod(access, name, desc, signature, exceptions);
//		  System.out.println(name + " " + desc + " " + signature);
		  if (mv != null) {
			  mv = new AddListenerCallTimerMethodAdapter(mv);	           
		  }	    
		  return mv;
	  }

	}

