package org.objectweb.asm.util;

import org.objectweb.asm.ClassWriter;
import org.objectweb.asm.MethodAdapter;
import org.objectweb.asm.MethodVisitor;
import org.objectweb.asm.Opcodes;


public class AddListenerCallTimerMethodAdapter extends MethodAdapter implements Opcodes {
	  public AddListenerCallTimerMethodAdapter(MethodVisitor mv) {
	    super(mv);
	  }
	  
	  @Override
	  public void visitMethodInsn(int opcode, String owner, String name, String desc, final int instructionByte) {		 
		  if (opcode == INVOKEVIRTUAL) {
			  System.out.println(opcode + " " + name + " " + desc);
		  } else
			  mv.visitMethodInsn(opcode, owner, name, desc, instructionByte);
	  }
	  
	  @Override
	  public void visitInsn(int opcode, final int instructionByte) {
		  mv.visitInsn(opcode, instructionByte);	 
	  }
}