package usi.instrumentation;

import java.lang.reflect.Array;
import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import java.util.Map;

import ch.usi.inf.sape.graph.Edge;
import ch.usi.inf.sape.graph.Node;
import ch.usi.inf.sape.graph.example.ExampleEdge;
import ch.usi.inf.sape.graph.example.ExampleNode;
//import soot.util.IdentityHashSet;
import usi.instrumentation.deserializer.FieldForestDeserializer;
import usi.instrumentation.stack.RecursionStorage;

public class FieldProfiler {
	
	
	public static void trackReference (Object ref, Object ref2,  Object field) {
		trackReference(ref, ref2, field, false);
	}
	
	public static void trackReference (Object ref, Object ref2,  Object field, boolean atEnd) {
		if (Configuration.LIMIT_TO_SPECIFIC_THREAD) {
			if (!Thread.currentThread().getName().equals(Configuration.THREAD_NAME)) {
				return;
			}
		}
		CCT cur = CCT.curCCT.get();
		Object[] names = cur.stack.enteredRepetitionFromTop();
		
		if (names!=null) {
			usi.instrumentation.stack.Node<String> name = (usi.instrumentation.stack.Node<String>)names[0];
			usi.instrumentation.stack.Node<String> pointer = (usi.instrumentation.stack.Node<String>)names[1];		
			String str = (String) field;
			Counter c = LoopProfiler.map.get(name);

			if (c!=null) {
				ArrayList<InputCounter> list = null;
				if (c.input.containsKey(c.findAlivePosition())) {
					list = c.input.get(c.findAlivePosition());
					for (InputCounter ic: list) {
						if (ic.elements.contains(ref) && !atEnd) {
								ic.accessedElements.add(ref);				
							return;
						}
					}
				} 
			}
			for (RecursionStorage rs : cur.recSet) {
				if (rs.node.equals(name) && rs.pointers.contains(pointer)) {	
					ArrayList<InputCounter> in = null;
					if (rs.input.containsKey(rs.counters.size()-1)) {
						in = rs.input.get(rs.counters.size()-1);
						for (InputCounter ic: in) {
							if (ic.elements.contains(ref) && !atEnd) {
								if (!ic.accessedElements.contains(ref)) {
									ic.accessedElements.add(ref);
								}
								return;
							} 
						}
					}
				}
			}
				
			InputCounter counter = null;
			String fieldName = str.split("->")[1];
			boolean edgeFound = false; 
			String className = ref.getClass().getName();			
			if (FieldForestDeserializer.dataStructure.get(str)!=null)
			while(!edgeFound) {
				for (Node node: FieldForestDeserializer.dataStructure.get(str).getBody()) {
					if (((ExampleNode)node).getLabel().replaceAll("/", ".").equals(className)) {
						String[] fieldNames = null;
						for (Edge e: node.getOutEdges()) {
							if (((ExampleEdge)e).getLabel().equals(fieldName) || 
									((ExampleEdge)e).getLabel().contains(","+fieldName) ||
									((ExampleEdge)e).getLabel().contains(fieldName+",")) {
								
								ExampleEdge edge = (ExampleEdge)e;
								if (edge.getLabel().contains(",")) {
									
									fieldNames = edge.getLabel().split(",");
								} else {
									fieldNames = new String[] {fieldName};
								}
								
							}
						}
						
						if (fieldNames==null) {
							if (className.equals(ref.getClass().getSuperclass().getName()) ||
									ref.getClass().getSuperclass().getName().equals("java.lang.Object")) {
								return;
							}
							className = ref.getClass().getSuperclass().getName();
						} else {
							edgeFound=true;
							ArrayList<Object> accessedElements = new ArrayList<Object>();
								
							counter = traverse(((ExampleNode)node).getLabel().replaceAll("/", "."), 
									ref, fieldNames, new InputCounter(new HashSet<Object>(), 0, accessedElements, 1,
											FieldForestDeserializer.dataStructure.get(str), str));
							if (counter!=null) {
								if (counter.elements.contains(ref)) {
									counter.accessedElements.add(ref);
								}	
								
								if (counter.elements.contains(ref2)) {
									if (ref2!=null)
										counter.accessedElements.add(ref2);
								}								
							}
							
							break;
						}
						
					} 
				} break;
			}
			
			if (counter==null) return;
			if (c!=null) {
				
				ArrayList<InputCounter> list = null;
				if (c.input.containsKey(c.findAlivePosition())) {
					list = c.input.get(c.findAlivePosition());
					for (InputCounter ic : list) {
						if (ic.merges(counter)) {
							ic.merge(counter, atEnd);
							return;
						}
					}
				} else {
					list = new ArrayList<InputCounter>();
				}
				list.add(counter);
				c.input.put(c.findAlivePosition(), list);				
			}
			
			for (RecursionStorage rs : cur.recSet) {
				if (rs.node.equals(name) && rs.pointers.contains(pointer)) {
					if (rs!=null) {
						ArrayList<InputCounter> in = null;
						if (rs.input.containsKey(rs.counters.size()-1)) {
							in = rs.input.get(rs.counters.size()-1);
							for (InputCounter ic : in) {
								
								if (ic.merges(counter)) {
									ic.merge(counter, atEnd);
									return;
								}
							}
							
						} else {
							in = new ArrayList<InputCounter>();
							
						}
						
						in.add(counter);
						rs.input.put(rs.counters.size()-1, in);				
					}
					
					break;
				}
			}
		} 
	}
	private static InputCounter traverse(String className, Object ref, String[] fieldNames, InputCounter counter) {
		
		try {
			
			for (String fieldName: fieldNames) {				
				boolean leave = false;
			
				if (ref==null) return counter;
				Class clazz = ref.getClass();
				Field f = null;
				boolean found = false;
				while (!found) {
					for (Field tempField: clazz.getDeclaredFields()) {
						if (tempField.getName().equals(fieldName)) {
							found = true;
							f = tempField;
							break;
						}
					}
					
					clazz = clazz.getSuperclass();
					if (clazz.getName().equals("java.lang.Object")) {
						break;
					}
				}
				
				if (f!=null) {
					counter.edgeNumber++;
					if (!counter.elements.contains(ref)) {
						counter.number++;
				
						
						if (counter.numberPerType.containsKey(ref.getClass().getName())) {
							counter.numberPerType.put(ref.getClass().getName(), 
									counter.numberPerType.get(ref.getClass().getName())+1);
						} else {
							counter.numberPerType.put(ref.getClass().getName(), 1);
						}
						
						counter.elements.add(ref);
					
					} else {					
						continue;
					}
					f.setAccessible(true);
					Object newRef = f.get(ref);
					if (newRef!=null) {
						if (newRef.getClass().getName().contains("[")) {
							List list = getRefFromArray(newRef, newRef.getClass().getName(), new ArrayList<Object>());
							for (Object obj: list) {
								String[] newFieldNames = getFieldNames(counter, obj.getClass().getName());
								if (newFieldNames!=null) {
									counter = traverse(obj.getClass().getName(), obj, newFieldNames, counter);																			
								} else {
									leave = true;
									break;
								}
							}
							if (leave) {
								continue;
							}
						} else {
							String[] newFieldNames = getFieldNames(counter, newRef.getClass().getName());
							if (newFieldNames!=null) {
								boolean foundCollection = false;
								for (String name: newFieldNames) {
									if (name.contains("<Collection>")) {
										List list = getCollectionElements(newRef, name, new ArrayList<Object>());
										foundCollection = true;
										for (Object obj: list) {
											newFieldNames = getFieldNames(counter, obj.getClass().getName());
											if (newFieldNames!=null) {
												counter = traverse(obj.getClass().getName(), obj, newFieldNames, counter);																			
											} else {
												leave= true; 
												break;
											}
										} 
										if (leave) {
											break;
										}
									}
								} 
								if (leave) {
									continue;
								}
								if (!foundCollection) {
									
									counter = traverse(newRef.getClass().getName(), newRef, newFieldNames, counter);	
									
								}
							} else {
								continue;
							}
						}
						
					} else {
						continue;
					}
				} 
			}
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		}
		
		return counter;
	}
	
	private static List<Object> getRefFromArray (Object ref, String className, List<Object> list) {
		
		int length = Array.getLength(ref);
		
		for (int i = 0; i<length; i++) {
			Object obj = Array.get(ref, i);
			if (obj!=null) {
				if (obj.getClass().getName().contains("[")) {
					list = getRefFromArray(obj, obj.getClass().getName(), list);
				} else {
					list.add(obj);
				}
				
			}
		}
		return list;
	}
	
	private static String[] getFieldNames (InputCounter counter, String className) {
		boolean edgeFound = false;
		while (!edgeFound) {
			boolean foundInBody = false;
			for (Node node: counter.loop.getBody()) {
				if (((ExampleNode)node).getLabel().replaceAll("/", ".").equals(className)) {
					foundInBody = true;
					String[] fieldNames = null;
					for (Edge e: node.getOutEdges()) {
						if (counter.loop.getBody().contains(e.getTarget())) {							
							ExampleEdge edge = (ExampleEdge)e;
							if (edge.getLabel().contains(",")) {
								fieldNames = edge.getLabel().split(",");
							} else {
								if (!edge.getLabel().equals("")) {
									
									fieldNames = new String[] {edge.getLabel()};									
								} else {
									className = ((ExampleNode)e.getTarget()).getLabel().replaceAll("/", ".");
								}
							}
							
						} 
						if (fieldNames!=null) return fieldNames;
					}
				}
			}
			if (!foundInBody) return null;			
		}
		return null;
	}
	
	private static List getCollectionElements (Object ref, String line, List<Object> list) {
		
		if (ref instanceof Collection) {
			Collection collection = (Collection)ref; 
			int length = collection.size();
			for (Object obj: collection) {
				if (obj!=null) {
					if (obj instanceof Collection || obj instanceof Map) {
						list = getCollectionElements(obj, line, list);
					} else {
						list.add(obj);
					}
					
				}
			}
		} else if (ref instanceof Map) {
			Map map = (Map) ref;
			list = getCollectionElements(map.keySet(), line, list);
			list = getCollectionElements(map.values(), line, list);
		}
		
		return list;
	}
	public static void trackArray (Object ref, int index,  Object field) {
		trackArray(ref, index, field, false);
	}
	
	public static void trackArray (Object ref, int index, Object field, boolean atEnd) {
		if (Configuration.LIMIT_TO_SPECIFIC_THREAD) {
			if (!Thread.currentThread().getName().equals(Configuration.THREAD_NAME)) {
				return;
			}
		}
		CCT cur = CCT.curCCT.get();
		Object[] names = cur.stack.enteredRepetitionFromTop();
		if (names!=null) {
			usi.instrumentation.stack.Node<String> name = (usi.instrumentation.stack.Node<String>)names[0];
			usi.instrumentation.stack.Node<String> pointer = (usi.instrumentation.stack.Node<String>)names[1];
			String str = (String) field;
			Counter c = LoopProfiler.map.get(name);
			
			if (c!=null) {
				ArrayList<InputCounter> list = null;
				if (c.input.containsKey(c.findAlivePosition())) {
					list = c.input.get(c.findAlivePosition());
					for (InputCounter ic: list) {
						if (ic.accessedElements.contains(ref) && !atEnd) {// || ) {
							if (!ic.accessedElements.contains(index)) {
								ic.accessedElements.add(index);
							}
							return;
						}
						
					}
				} 
			}
			
			for (RecursionStorage rs : cur.recSet) {
				if (rs.node.equals(name) && rs.pointers.contains(pointer)) {	
					ArrayList<InputCounter> in = null;
					if (rs.input.containsKey(rs.counters.size()-1)) {
						in = rs.input.get(rs.counters.size()-1);
						for (InputCounter ic: in) {
							if (ic.accessedElements.contains(ref) && !atEnd) {// || ) {
								if (!ic.accessedElements.contains(index)) {
									ic.accessedElements.add(index);
								}
								return;
							}
						}
					}
				}
			}
			InputCounter counter = null;
			if (ref!=null)
				counter = sizeOfArray(ref, new InputCounter(new HashSet<Object>(), 0, new ArrayList<Object>(), 0, null, str), index, false); 
			if (counter==null) return;			
			if (c!=null) {
				
				ArrayList<InputCounter> list = null;
				if (c.input.containsKey(c.findAlivePosition())) {
					list = c.input.get(c.findAlivePosition());
					if (list.contains(counter)) return;
					
				} else {
					list = new ArrayList<InputCounter>();
				}
				for (InputCounter ic : list) {
					if (ic.merges(counter)) {
						ic.merge(counter, atEnd);
						return;
					} 
					
				}
				
				list.add(counter);
				c.input.put(c.findAlivePosition(), list);				
			}
			for (RecursionStorage rs : cur.recSet) {
				if (rs.node.equals(name) && rs.pointers.contains(pointer)) {
					if (rs!=null) {
						ArrayList<InputCounter> in = null;
						if (rs.input.containsKey(rs.counters.size()-1)) {
							in = rs.input.get(rs.counters.size()-1);
							if (in.contains(counter)) return;
							
						} else {
							in = new ArrayList<InputCounter>();
							
						}
						for (InputCounter ic : in) {
							if (ic.merges(counter)) {
								ic.merge(counter, atEnd);
								return;
							} 
							
						}
						in.add(counter);
						rs.input.put(rs.counters.size()-1, in);				
					}
					
					break;
				}
			}
		} else {
		}
		
	}
	
	private static InputCounter sizeOfArray(Object ref, InputCounter ic, int index, boolean recursive) {
		int length = Array.getLength(ref);
		if (!recursive) {			
			ic.accessedElements.add(ref);
			if (!ic.accessedElements.contains(index))
				ic.accessedElements.add(index);
		}
		for (int i = 0; i<length; i++) {
			Object obj = Array.get(ref, i);
			if (obj!=null) {
				
				if (obj.getClass().isArray()) {
					sizeOfArray(obj, ic, index, true);
				} else {
					if (!ic.elements.contains(obj)) {
						ic.elements.add(obj);
						ic.number++;						
					} else {
					}					
				}
					ic.edgeNumber++;
				
			} else {
				ic.number++;
			}
		}
		
		return ic;
	}
	
	private static InputCounter sizeOfCollection(Object ref, InputCounter ic) {
		
		if (ref instanceof Collection) {
			Collection collection = (Collection) ref;
			ic.accessedElements.add(ref);
			for (Object obj: collection) {
				if (obj!=null) {
					if (obj instanceof Collection || obj instanceof Map) {
						ic = sizeOfCollection(obj, ic);
					} else {
						if (!ic.elements.contains(obj)) {
							ic.elements.add(obj);
							ic.number++;							
						}
						ic.edgeNumber++;
					}
					
				}
			}
			
		} else if (ref instanceof Map) {
			Map map = (Map)ref;
			ic.accessedElements.add(ref);
			ic = sizeOfCollection(map.values(), ic);
		}
		return ic;
	}
	
	public static void trackCollection (Object ref, Object field) {
		trackCollection(ref, field, false);
	}
	
	public static void trackCollection (Object ref, Object field, boolean atEnd) {
		
		if (Configuration.LIMIT_TO_SPECIFIC_THREAD) {
			if (!Thread.currentThread().getName().equals(Configuration.THREAD_NAME)) {
				return;
			}
		}
		
		CCT cur = CCT.curCCT.get();
		Object[] names = cur.stack.enteredRepetitionFromTop();
		
		if (names!=null) {
			usi.instrumentation.stack.Node<String> name = (usi.instrumentation.stack.Node<String>)names[0];
			usi.instrumentation.stack.Node<String> pointer = (usi.instrumentation.stack.Node<String>)names[1];
			String str = (String) field;
			Counter c = LoopProfiler.map.get(name);
			if (c!=null) {
				
				ArrayList<InputCounter> list = null;
				if (c.input.containsKey(c.findAlivePosition())) {
					list = c.input.get(c.findAlivePosition());
					InputCounter ic = null;
					for (int i =0; i<list.size(); i++) {
						ic = list.get(i);
						if (ic.accessedElements.contains(ref) && !atEnd) {// || ) {
							ic.accessedElements.add(ref);
							return;
						}
					}
				} 
			}
			for (RecursionStorage rs : cur.recSet) {
				if (rs.node.equals(name) && rs.pointers.contains(pointer)) {	
					ArrayList<InputCounter> in = null;
					if (rs.input.containsKey(rs.counters.size()-1)) {
						in = rs.input.get(rs.counters.size()-1);
						for (InputCounter ic: in) {
							if (ic.accessedElements.contains(ref) && !atEnd) {// || ) {
								ic.accessedElements.add(ref);
								return;
							}
						}
					}
				}
			}
				
							
							
			InputCounter counter = sizeOfCollection(ref, new InputCounter(new HashSet<Object>(), 0, new ArrayList<Object>(), 0,  null, str)); 
						
			if (counter==null) return;
			if (c!=null) {
				
				ArrayList<InputCounter> list = null;
				if (c.input.containsKey(c.findAlivePosition())) {
					list = c.input.get(c.findAlivePosition());
					if (list.contains(counter)) return;
					
				} else {
					list = new ArrayList<InputCounter>();
				}
				for (InputCounter ic : list) {
					if (ic.merges(counter)) {
						ic.merge(counter, atEnd);
						return;
					} 	
				}
				list.add(counter);
				c.input.put(c.findAlivePosition(), list);				
			}
			for (RecursionStorage rs : cur.recSet) {
				if (rs.node.equals(name) && rs.pointers.contains(pointer)) {
					if (rs!=null) {
						ArrayList<InputCounter> in = null;
						if (rs.input.containsKey(rs.counters.size()-1)) {
							in = rs.input.get(rs.counters.size()-1);
							if (in.contains(counter)) return;
							
						} else {
							in = new ArrayList<InputCounter>();
							
						}
						for (InputCounter ic : in) {
							if (ic.merges(counter)) {
								ic.merge(counter, atEnd);
								return;
							} 
						}
						
						in.add(counter);
						rs.input.put(rs.counters.size()-1, in);				
					}
					
					break;
				}
			}
		} 
		
	}
	
	public static void trackNews (Object typeName) {
		if (Configuration.LIMIT_TO_SPECIFIC_THREAD) {
			if (!Thread.currentThread().getName().equals(Configuration.THREAD_NAME)) {
				return;
			}
		}
		CCT cur = CCT.curCCT.get();
		Object[] names = cur.stack.enteredRepetitionFromTop();
		if (names!=null) {
			usi.instrumentation.stack.Node<String> name = (usi.instrumentation.stack.Node<String>)names[0];
			usi.instrumentation.stack.Node<String> pointer = (usi.instrumentation.stack.Node<String>)names[1];
			Counter c = LoopProfiler.map.get(name);
			if (c!=null) {
				ArrayList<InputCounter> list = null;
				if (c.input.containsKey(c.findAlivePosition())) {
					list = c.input.get(c.findAlivePosition());
					NewObjectCounter noc = null;
					if (NewObjectCounter.map.containsKey(list)) {
						noc = NewObjectCounter.find(list);
					} else {
						noc = new NewObjectCounter(list);
						
					}
					int num = 1;
					if (noc.numberPerType.containsKey((String)typeName)) {
						num = noc.numberPerType.get((String)typeName) + 1;
					}
					noc.numberPerType.put((String)typeName, num);
					
				} 
			}
			for (RecursionStorage rs : cur.recSet) {
				if (rs.node.equals(name) && rs.pointers.contains(pointer)) {	
					ArrayList<InputCounter> list = null;
					if (rs.input.containsKey(rs.counters.size()-1)) {
						list = rs.input.get(rs.counters.size()-1);
						NewObjectCounter noc = null;
						if (NewObjectCounter.map.containsKey(list)) {
							noc = NewObjectCounter.find(list);
						} else {
							noc = new NewObjectCounter(list);
							
						}
						int num = 1;
						if (noc.numberPerType.containsKey((String)typeName)) {
							num = noc.numberPerType.get((String)typeName) + 1;
						}
						noc.numberPerType.put((String)typeName, num);
					}
				}
			}
		} 
	}
	
	public static void recountReferences () {
		if (Configuration.LIMIT_TO_SPECIFIC_THREAD) {
			if (!Thread.currentThread().getName().equals(Configuration.THREAD_NAME)) {
				return;
			}
		}
		CCT cur = CCT.curCCT.get();
		Object[] names = cur.stack.enteredRepetitionFromTop();
		if (names!=null) {
			usi.instrumentation.stack.Node<String> name = (usi.instrumentation.stack.Node<String>)names[0];
			usi.instrumentation.stack.Node<String> pointer = (usi.instrumentation.stack.Node<String>)names[1];
			
			ArrayList<InputCounter> list = null;
			Counter c = LoopProfiler.map.get(name);
			if (c!=null) {
				int pos = c.findAlivePosition();
				if (c.input.containsKey(pos)) {
					list = c.input.get(pos);
					
					
				} 
			} else {
				for (RecursionStorage rs : cur.recSet) {
					if (rs.node.equals(name) && rs.pointers.contains(pointer)) {	
						if (rs.input.containsKey(rs.counters.size()-1)) {
							list = rs.input.get(rs.counters.size()-1);
							
						}
					}
				}
			}
			
			
			if (list!=null) {
				ArrayList<InputCounter> tempList = (ArrayList<InputCounter>) list.clone();
				
				for (InputCounter ic: tempList) {
					if (ic.numberPerType!=null && !ic.numberPerType.isEmpty() && ic.loop!=null) {
						trackReference(ic.accessedElements.get(0), null, ic.name, true);
						if (ic.accessedElements.size()>2) {
							trackReference(ic.accessedElements.get(ic.accessedElements.size()-1), null, ic.name, true);
							trackReference(ic.accessedElements.get(ic.accessedElements.size()-2), null, ic.name, true);
						}
					} else {
						if (ic.name.startsWith("[")) {
							trackArray(ic.accessedElements.get(0), 0, ic.name, true);
						} else {
							if (ic.accessedElements.size()!=0)
								trackCollection(ic.accessedElements.get(0), ic.name, true);
						}					
					}
				}
			}
		}
		
	}

	private static void removeDuplicateInputs(ArrayList<InputCounter> list) {
		if (list.size()>1) {
			
			ArrayList<InputCounter> toRemove = new ArrayList<InputCounter>();
			for (InputCounter ic: list) {
				for (InputCounter ic2: list) {
					if (ic!=ic2 && !toRemove.contains(ic2)) {
						if (ic.name.equals(ic2.name)) {
							if (ic.elements.size()>ic2.elements.size()) {
								toRemove.add(ic2);
							} else {
								toRemove.add(ic);
							}
						} else {
							boolean terminate = false;
							for (Object obj: ic.elements) {
								for (Object obj2: ic2.elements) {
									if (obj == obj2) {
										if (ic.elements.size()>ic2.elements.size()) {
											toRemove.add(ic2);
										} else {
											toRemove.add(ic);
										}
										terminate = true;
										break;
									}
								}
								if (terminate) {
									break;
								}
							}
						}
					}
				}
				
			}
			if (!toRemove.isEmpty()) {
				list.removeAll(toRemove);
			}
			
			
		}
		
	}
}
