package usi.instrumentation;

import java.io.IOException;
import java.util.concurrent.ConcurrentHashMap;

import usi.instrumentation.stack.Node;
import usi.instrumentation.stack.Node.RepetitionEntrance;




public final class LoopProfiler {
	
	public static ConcurrentHashMap<Node<String>, Counter> map = new ConcurrentHashMap<Node<String>, Counter>();

	 public static void updateMap(int i, Node<String> name) {
		Counter counter = map.get(name);
		switch (i) {
		case 0:
			
			if (counter == null) { 
				System.out.println("counter is null " + name.data);
				countIF_LOOP_Before(name.data);
				break;
			}
			int position = counter.findAlivePosition();
			int count = counter.count_LOOP.get(position);
			count++;
			counter.count_LOOP.remove(position);
			counter.count_LOOP.add(position,count);
			name.enteredRepetition = RepetitionEntrance.ITERATING;
			
			break;
			
		case 1:
			name.extra.numberOfEntrancies++;
			if (Configuration.OPT && counter.count_LOOP.size()>1000) {
				try {
					BufferFlusher.flush(name, counter.count_LOOP, counter.input);
					counter.count_LOOP.clear();
					counter.input.clear();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			name.enteredRepetition = RepetitionEntrance.ENTERED;
			counter.count_LOOP.add(new Integer(0));	
			counter.alivePositions.put(counter.count_LOOP.size()-1, true);
			counter.descendants.put(counter.count_LOOP.size()-1, CCT.findRelatedIteration(name));
			
			
			break;
		case 2:
			
			
			name.extra.totalNumberOfIterations = name.extra.totalNumberOfIterations + counter.count_LOOP.get(counter.count_LOOP.size()-1);
			
			if (counter.count_LOOP.get(counter.count_LOOP.size()-1)<name.extra.minNumberOfIterations) {
				name.extra.minNumberOfIterations = counter.count_LOOP.get(counter.count_LOOP.size()-1);
			}
			
			if (counter.count_LOOP.get(counter.count_LOOP.size()-1)>name.extra.maxNumberOfIterations) {
				name.extra.maxNumberOfIterations = counter.count_LOOP.get(counter.count_LOOP.size()-1);
			}
			name.enteredRepetition = RepetitionEntrance.ITERATING;
			counter.alivePositions.put(counter.findAlivePosition(), false);
			break;
		default:
			break;
		}
	}



	
	 public static void countIF_LOOP(java.lang.Object name) {
		 if (Configuration.LIMIT_TO_SPECIFIC_THREAD) {
				if (!Thread.currentThread().getName().equals(Configuration.THREAD_NAME)) {
					return;
				}
			}
		Node<String> node = CCT.getNode((String) name);
		if (node == null) {
			System.out.println("node is null, so can't increase loop " + name);
			return;
		}
		if (!Configuration.COUNT_COST) return;
		updateMap(0, node);
		

	}
	 
	 public static void countIF_LOOP_After(java.lang.Object name) {
		 if (Configuration.LIMIT_TO_SPECIFIC_THREAD) {
				if (!Thread.currentThread().getName().equals(Configuration.THREAD_NAME)) {
					return;
				}
			}
		 Node<String> node = CCT.getNode((String) name);
		  if (node!=null) {
			  if (Configuration.TRACK_INPUTS) {
				  FieldProfiler.recountReferences();
			  }
			  if (Configuration.COUNT_COST)
				  updateMap(2, node);
			 CCT.removeFromCCT((String) name); 
		 }
		 
	 }
	 
	 private static String nameToPass (String name) {
		return name;
	 }
	
	 public static void countIF_LOOP_Before(java.lang.Object name) {
		 if (Configuration.LIMIT_TO_SPECIFIC_THREAD) {
				if (!Thread.currentThread().getName().equals(Configuration.THREAD_NAME)) {
					return;
				}
				
			}
		 CCT.addToCCT(nameToPass((String) name));
		 if (!Configuration.COUNT_COST) return;
		 Node<String> node = CCT.getNode((String) name);
		 if (node == null) {
				System.out.println("node is null, so can't put it in map " + name);
		 }
		
			 if (!map.containsKey(node)) {
				 map.put(node, new Counter());
			 }			 
		 
		 updateMap(1, node);

	}

}
