package usi.instrumentation.deserializer;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.HashMap;
import java.util.Map;

import ch.usi.inf.sape.graph.Edge;
import ch.usi.inf.sape.graph.Node;
import ch.usi.inf.sape.graph.example.ExampleEdge;
import ch.usi.inf.sape.graph.example.ExampleNode;
import ch.usi.inf.sape.graph.loop.Loop;
import ch.usi.inf.sape.graph.loop.LoopForest;

public class FieldForestDeserializer {

	/*
	 * HashMap where every field owner->name points to a recursive data Structure
	 */
	
	public static Map<String, Loop> dataStructure = new HashMap<String, Loop>();
	
	public FieldForestDeserializer(String path, String name) {
		try {
		    
			
			
			File file = new File(path + "forest-" + name + "-dependability.obj");
			ObjectInputStream in = new ObjectInputStream(new FileInputStream(file));
			//System.out.println(file.getAbsolutePath());
			LoopForest forest = (LoopForest)in.readObject();
			
			//System.out.println(tree.getRootElement().data + " " + tree.getRootElement().extra.totalNumberOfIterations);
			in.close();
			
			for (Loop loop: forest.getTreeRoots()) {
				//by logic i should take edges that source and target have nodes in the body and that edge would point to a loop
				//prototype at the moment as duplicates may exist
				//TODO change that
				for (Node node: loop.getBody()) {
					for (Edge e: node.getOutEdges()) {
						ExampleEdge edge = (ExampleEdge)e;
						if (loop.getBody().contains(edge.getTarget())) {
							if (!edge.getLabel().equals("")) {
								//System.out.println(((ExampleNode)node).getLabel() + "->" + edge.getLabel());
								if (edge.getLabel().contains(",")) {
									for (String str: edge.getLabel().split(",")) {
										dataStructure.put(((ExampleNode)node).getLabel()+ "->" + str, loop);
									}
								} else {
									dataStructure.put(((ExampleNode)node).getLabel()+ "->" + edge.getLabel(), loop);
								}
							}
						}
					}
				
				}
			}
			
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} 
	}

}
