package usi.instrumentation.deserializer;

import java.util.ArrayList;
import java.util.List;

public class IndicesBlock {
	
	public String blockName;
	List<IndicesBlock> succ;
	List<Integer> instructionIds;
	public boolean fakeBlock = false;
	public boolean hasFather;
	
	public IndicesBlock(String blockName, List<Integer> instructionIds) {
		
		this.blockName = blockName;
		this.instructionIds = instructionIds;
		
	}
	
	public void setSucc(IndicesBlock sucBlock) {
		
		if (succ == null) succ = new ArrayList<IndicesBlock>();
		
		succ.add(sucBlock);
		
	}
		
	public void removeSucc(IndicesBlock sucBlock) {
		
		if (succ == null) return;
		
		succ.remove(sucBlock);
		
	}
	
	public List<IndicesBlock> getSucc() {
		
		return succ;
		
	}
	
	public List<Integer> getInstructionIds () {
		return instructionIds;
	}
	
	/**
	 * 
	 * @param b
	 * @return father IndicesBlock if their instructionIDs intersect, null otherwise 
	 */
	public void intersects (IndicesBlock b) {
		boolean found = false;
		
		if (!instructionIds.isEmpty() && !b.instructionIds.isEmpty()) {
			if (instructionIds.containsAll(b.instructionIds) || b.instructionIds.containsAll(instructionIds)) {
				found = true;
			}			
		}
		/*for (Integer i: instructionIds) {
			if (b.instructionIds.contains(i)) {
				found = true;
				break;
			}
		}*/
		//means that one of the parents, but not neccessarely direct
		if (found) {
			boolean same = false;
			if (instructionIds.size()>b.instructionIds.size()) {
				instructionIds.removeAll(b.instructionIds);
				if (this.blockName.contains("-") && b.blockName.contains("-")) {
					String nameA = blockName.substring(0, blockName.indexOf("-"));
					String nameB = b.blockName.substring(0, b.blockName.indexOf("-"));
					if (!nameA.equals(nameB)) {
						same = true;						
					}
				} else {
					same = true;
				}
				if (same && !b.hasFather) {
					b.hasFather = true;
					setSucc(b);
				}
					
			} else {
				b.instructionIds.removeAll(instructionIds);
				if (this.blockName.contains("-") && b.blockName.contains("-")) {
					String nameA = blockName.substring(0, blockName.indexOf("-"));
					String nameB = b.blockName.substring(0, b.blockName.indexOf("-"));
					if (!nameA.equals(nameB)) {
						same = true;						
					}
				} else {
					same = true;
				}
				if (same && !hasFather) {
					hasFather = true;
					b.setSucc(this);
				}
			}
		} else if (b.fakeBlock && !hasFather) {
			b.setSucc(this);
		} else if (fakeBlock && !b.hasFather) {
			setSucc(b);
		}
	
	}
	
	public void merge (IndicesBlock b) {
		for (Integer i: b.instructionIds) {
			if (!instructionIds.contains(i)) {
				instructionIds.add(i);
			}
		}
	}

}
