package usi.instrumentation.deserializer;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import ch.usi.inf.sape.graph.Edge;
import ch.usi.inf.sape.graph.Node;
import ch.usi.inf.sape.graph.example.ExampleNode;
import ch.usi.inf.sape.graph.example.FullNode;
import ch.usi.inf.sape.graph.loop.Loop;
import ch.usi.inf.sape.graph.loop.LoopForest;

public class RecursionForestDeserializer {

	/*
	 * HashMap where every method if header points to other headers if there are
	 */
	
	public static Map<String, ArrayList<String>> dataStructure = new HashMap<String, ArrayList<String>>();
	
	public RecursionForestDeserializer(String path, String name) {
		try {
		    
			
			File file = new File(path + "recursion-" + name + ".obj");
			ObjectInputStream in = new ObjectInputStream(new FileInputStream(file));
			//System.out.println(file.getAbsolutePath());
			LoopForest forest = (LoopForest)in.readObject();
			
			//System.out.println(tree.getRootElement().data + " " + tree.getRootElement().extra.totalNumberOfIterations);
			in.close();
			
			for (Loop loop: forest.getTreeRoots()) {
				//System.out.println(loop.getHeaders().size());
				ArrayList<String> list = new ArrayList<String>();
				for (Node node: loop.getHeaders()) {
					FullNode n = (FullNode)node;
					String method = n.getLabel().replaceAll("\\.", "/").replace("(", "/(");
					list.add(method);
				}
				for (String str: list) {
					if (dataStructure.containsKey(str)) {
						dataStructure.get(str).addAll(list);
					} else {
						//System.out.println(str);
						dataStructure.put(str, new ArrayList<String>(list));
					}
				}
				
			}
			
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} 
	}

}
