package usi.instrumentation.dumper;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class AbstractWriter implements IterationWriteble {
	
	int [] arr = new int [10000000];

	@Override
	public void calculate(String[] elements, boolean step) {
		int el[] = new int[elements.length];
		for (int i = 0; i<el.length; i++) {
			if (elements[i].matches("\\d+"))
				el[i] = Integer.parseInt(elements[i]);
		}
		
		for (int i = 0; i<el.length; i++) {
			if (step) {
				arr[el[i]] = arr[el[i]] + el[i];
			} else {
				arr[el[i]]++;  				
			}
		}
	}

	@Override
	public void flush(String name) {
		try {
			File file = new File(name);
			BufferedWriter bw = new BufferedWriter(new FileWriter(file));
			int length = 0;
			for (int i = arr.length-1; i>0; i--) {
				if (arr[i]>0) {
					length = i+1;
					break;
				}
			}
			
			long sum = 0;
			for (int i = 0; i<length; i++) {
				sum = sum + arr[i];
				if (i % 100 == 0) {
					if (sum != 0)
						bw.write(i + "\t" + sum + "\r\n");						
				}
			}
			bw.write(((length/100)*100+100) + "\t" + sum + "\r\n");
			
			bw.flush();
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	@Override
	public void read(String name, boolean step) {
		try {
			
			BufferedReader br = new BufferedReader(new FileReader(new File(name)));
			String line;
			String hash;
			String[] elements;
			System.out.println("dumping from .... " + name);
			while ((line = br.readLine()) != null) {
				if (line.contains(";")) {
					hash = line.substring(0, line.indexOf(";"));
					elements = line.substring(line.indexOf(";")+1, line.length()).split(",");
					
				} else {
					elements = line.split(",");
				}
				
				calculate(elements, step);
			}
			
			br.close();
			
			
		} catch (FileNotFoundException e) {
			System.err.println("couldn't read from " + name);
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

}
