package usi.instrumentation.dumper;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Vector;


public class IterativeData {
	
	
	
	
	
	//string may or may not contain curly brackets
	private ArrayList<EntryData> readPoints (String points) {
		ArrayList<EntryData> list = new ArrayList<EntryData>();
		int curveOpened = 0;
		boolean commaFound = false;
		String number = "";
		int counter = 0;
		for (int i = 0; i<points.length(); i++) {
			char token = points.charAt(i);
			if (token == '{') {
				curveOpened++;
				
			} else if (token == '}') {
				curveOpened--;
			
			} else if (token == ',') {
				if (curveOpened == 0) {
					commaFound = true;
				}
				
			}
			if (curveOpened == 0 && commaFound) {
				commaFound = false;
				if (number.contains("{")) {
					//should call method to form X,Y
					//otherwise there is no X, skip
					String y = number.substring(0, number.indexOf("{"));
					double yPoint = Double.parseDouble(y);
					String xs = number.substring(number.indexOf("{")+1, number.lastIndexOf("}"));
					String[] dots = formXY(xs);
					EntryData ed = new EntryData();
					ed.iterationNumber = yPoint;
					ed.dataPoints = new ArrayList<Double>();
					for (int j = 0; j<dots.length; j++) {
						
						double xPoint = Double.parseDouble(dots[j]);
						ed.dataPoints.add(xPoint);
						ed.innerPoints.put(ed.dataPoints.indexOf(xPoint), new ArrayList<Double>());
					}
					counter++;
				} 
				number = "";
				continue;
			}
			number = number + token;
			
		}
		return list;
	}
	
	//should be in form of \\d{\\d+,*},*
	private String[] formXY (String points) {
		//System.out.println(points + " " + points.length());
		int curveOpen = 0;
		String[] temp = new String[10];
		String number = "";
		int counter = 0;
		boolean commaDetected = false;
		for (int i = 0; i<points.length(); i++) {
			char token = points.charAt(i);
			if (token == '{') {
				curveOpen++;
			} else if (token == '}') {
				curveOpen--;
				if (curveOpen == 0 && (points.length() == i+1)) {
					commaDetected = true;
				}
			} else if (token == ',') {
				if (curveOpen == 0) {
					//System.out.println("happens");
					commaDetected = true;
				}
			} else {
				if (curveOpen == 0) {
					number = number + token;
				}
			}
			
			if (curveOpen == 0 && commaDetected) {
				commaDetected = false;
				temp[counter] = number;
				counter++;
			
				number = "";
				
			}
			
			
		}
		
		String[] dots = new String[counter];
		for (int i = 0; i<counter; i++) {
			//System.out.println("to " + i + " " + temp[i]);
			dots[i] = temp[i];
		}
		return dots;
	}
	private HashMap<String, List<EntryData>> readFile (String name) {
		HashMap<String, List<EntryData>> map = new HashMap<String, List<EntryData>>();
		try {
			BufferedReader br = new BufferedReader(new FileReader(new File(name)));
			String line;
			
			while ((line=br.readLine())!=null) {
				String tokens[] = line.split(":");
				String uniqueName = tokens[0];
				List<EntryData> vectors = null;
				if (map.containsKey(uniqueName)) {
					vectors = map.get(uniqueName);
				} else {
					vectors = new ArrayList<EntryData>();
					map.put(uniqueName, vectors);
				}
				
				
				ArrayList<EntryData> list = readPoints(tokens[2]);
				vectors.addAll(list);
				
			}
			
		} catch (FileNotFoundException e) {
			System.err.println("couldn't open file " + name);
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("couldn't read file " + name);
			e.printStackTrace();
		}
		
		
		return map;
		
	}
	
	private HashMap<String, String> readFileToString (String name) {
		
		HashMap<String, String> map = null;
		if (IterativeData.map == null) {
			map = new HashMap<String, String>();
		} else {
			map = IterativeData.map;
		}
		try {
			BufferedReader br = new BufferedReader(new FileReader(new File(name)));
			String line;
			
			while ((line=br.readLine())!=null) {
				String tokens[] = line.split(":");
				if (tokens.length!=3) continue;
				String uniqueName = tokens[0];
				
				String vectors = null;
				if (map.containsKey(uniqueName)) {
					vectors = map.get(uniqueName);
				} else {
					vectors = "";
					//map.put(uniqueName, vectors);
				}
				
				
				vectors = vectors + tokens[2];
				map.put(uniqueName, vectors);
			}
			
		} catch (FileNotFoundException e) {
			System.err.println("couldn't open file " + name);
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("couldn't read file " + name);
			e.printStackTrace();
		}
		
		
		return map;
		
	}
	
	public static HashMap<String, String> map;
	
	 public static void readData(String[] args) {

		 IterativeData id = new IterativeData();
		 for (String arg: args) {
			 map = id.readFileToString(arg);
			/* for (String entry: map.keySet()) {
			
			 }*/
			
		 }
		   	    
	}

}
