package usi.instrumentation.stack;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import usi.instrumentation.InputCounter;

public class RecursionStorage {

	public Node<String> node;
	public ArrayList<Node<String>> pointers;
	public ArrayList<Integer> counters;
	public Map<Integer, Integer> descendants;
	public Map<Integer, ArrayList<InputCounter>> input;
	public EdgeAnnotation extra;
	
	public RecursionStorage(Node<String> node, ArrayList<Integer> counters, EdgeAnnotation extra) {
		this.node = node;
		this.pointers = new ArrayList<Node<String>>();
		this.counters = counters;
		this.extra = extra;
		input = new HashMap<Integer, ArrayList<InputCounter>>();
		descendants = new HashMap<Integer, Integer>();
	}
	
	public void addPointer(Node<String> node) {
		if (!pointers.contains(node))
			pointers.add(node);
	}
	
}
