package usi.instrumentation.tracker;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.List;

import usi.instrumentation.StaticNames;

import ch.unisi.inf.sp.cfg.Block;
import ch.unisi.inf.sp.cfg.InstructionData;

public class BytecodeInstructionTracker {

	private static BufferedWriter bw;
	
	static {
		try {
			bw = new BufferedWriter(new FileWriter(new File(StaticNames.output + StaticNames.indName)));
		} catch (IOException e) {
			System.err.println("instructionIndices.txt couldn't be created.");
			e.printStackTrace();
		}
	}
	
	public static void writeIndexes (String methodName, List<Block> instructions)  {
		
		try {
			bw.write(methodName);
			//System.out.println("for " + methodName);
			for (Block block: instructions) {
				for (InstructionData id : block.getInstrs()) {
					if (id.instructionNumber>=0) {
						bw.write(","+id.instructionNumber);
						//System.out.println(id.instructionNumber);
					}
				}
			}
			
			bw.newLine();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public static void close() {
		try {
			bw.flush();
			bw.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	
}
