package usi.instrumentation.tree;

import java.util.HashSet;

import usi.instrumentation.CCT;
import usi.instrumentation.stack.Node;
import usi.instrumentation.stack.RecursionStorage;

public class FullTree extends AbstractTree implements TreeIR {
	
	private HashSet<RecursionStorage> recursions;
	private HashSet<String> repetitions;
	
	
    public void DFS (final CCT cur, final String name) {
    	recursions = cur.recSet;
    	repetitions = new HashSet<String>();
    	super.DFS(cur, name);
		
    }

	@Override
	protected boolean isEligible(Node<String> node) {
		return true;
	}

    private boolean isLoop (Node<String> node) {
    	if (node.data.contains("/")) return true;
    	return false;
    }
    
    private boolean isRecursive (Node<String> node) {
    	for (RecursionStorage rs: recursions) {
    		if (rs.node.equals(node)) {
    			return true;
    		}
    	}
    	
    	return false;
    }
	
	@Override
	protected void drawBackEdges(Node<String> node) {
		if (isLoop(node)) {
			/*String str = "["+node.extra.minNumberOfIterations + 
			".."+node.extra.maxNumberOfIterations+"]";*/
			String str = "["+node.extra.totalNumberOfIterations + "]";
			draw(node.hashCode(), node.hashCode(), str);
		}
		if (isRecursive(node)) {
			for (RecursionStorage rs: recursions) {
				if (rs.node.equals(node)) {
					if (!repetitions.contains(""+node.hashCode()+ "x"+rs.pointers.hashCode())) {
						repetitions.add("" + node.hashCode() + "x" + rs.pointers.hashCode());
						String str = ""+rs.counters.size();
						if (rs.counters.size()>1) {
							/*str = str + " [" + rs.extra.minNumberOfIterations +
							".." + rs.extra.maxNumberOfIterations + "]";*/
							str = str + " [" + rs.extra.totalNumberOfIterations + "]";
						}
						draw(rs.pointers.hashCode(), rs.node.hashCode(), str);
					} 
				}
			}			
		}
		
	}

    
}
