package usi.instrumentation.tree;

import java.util.HashSet;
import usi.instrumentation.CCT;
import usi.instrumentation.dumper.IterativeData;
import usi.instrumentation.stack.Node;
import usi.instrumentation.stack.RecursionStorage;

public class IterationTree extends AbstractTree implements TreeIR {
	
	private HashSet<RecursionStorage> recursions;
	//private HashSet<String> repetitions;
	
	
    public void DFS (final CCT cur, final String name) {
    	recursions = cur.recSet;
    	repetitions = new HashSet<String>();
    	super.DFS(cur, name);
		
    }

	@Override
	protected boolean isEligible(Node<String> node) {
		if (isLoop(node) || isRecursive(node)) return true;
		return false;
	}

    private boolean isLoop (Node<String> node) {
    	if (node.data.contains("-")) return true;
    	return false;
    }
    
    private boolean isRecursive (Node<String> node) {
    	for (RecursionStorage rs: recursions) {
    		if (rs.node.equals(node)) {
    			return true;
    		}
    	}
    	
    	return false;
    }
    

	@Override
	protected void drawBackEdges(Node<String> node) {
		if (isLoop(node)) {
			String str = "";
			if (IterativeData.map!=null)
			if (IterativeData.map.containsKey(""+node.hashCode())) {
				str = IterativeData.map.get(""+node.hashCode()).substring(0, IterativeData.map.get(""+node.hashCode()).length()-1);
				drawData(node.hashCode(), str);
			
			}
			
			//draw(node.hashCode(), node.hashCode(), "");
		}
		if (isRecursive(node)) {
			for (RecursionStorage rs: recursions) {
				if (rs.node.equals(node)) {
					boolean once = true;
					for (Node<String> n: rs.pointers) {
						//System.out.println(node.data + " is pointed by " + n.data);
						if (!repetitions.contains(""+node.hashCode()+ "x"+n.hashCode())) {
							repetitions.add("" + node.hashCode() + "x" + n.hashCode());
							String str = "";
							if (once) {
								if (IterativeData.map!=null)
								if (IterativeData.map.containsKey(""+node.hashCode())) {
									str = IterativeData.map.get(""+node.hashCode()).substring(0, IterativeData.map.get(""+node.hashCode()).length()-1);
									drawData(node.hashCode(), str);
								}
								once = false;
								
							}
							if (isEligible(n)) {
								draw(n.hashCode(), rs.node.hashCode(), "");															
							}
						}
					} 
				}
			}			
		}
		
	}
	
	 protected boolean putUp(Node<String> node) {
		 if (!isEligible(node) && node.father!=null) {
			 for (RecursionStorage rs: recursions) {
				 if (rs.pointers.contains(node)) { 
					 rs.pointers.remove(node);
					 rs.pointers.add(node.father);
					 //System.out.println(rs.pointer.data);
				 }
			 }
		 } 
		return super.putUp(node);
	}
    
}
