package usi.instrumentation.tree;


import java.util.HashSet;
import usi.instrumentation.CCT;
import usi.instrumentation.stack.Node;
import usi.instrumentation.stack.RecursionStorage;

public class RecursionTree extends AbstractTree implements TreeIR {
	
	private HashSet<RecursionStorage> recursions;
	private HashSet<String> repetitions;
	
	public void DFS (final CCT cur, final String name) {
		repetitions = new HashSet<String>();
		recursions = cur.recSet;
    	super.DFS(cur, name);
		
    	
    }

	@Override
	protected boolean isEligible(Node<String> node) {
		if (isRecursive(node)) return true;
		return false;
	}
	
	 private boolean isRecursive (Node<String> node) {
	    	for (RecursionStorage rs: recursions) {
	    		if (rs.node.equals(node)) {
	    			return true;
	    		}
	    	}
	    	
	    	return false;
	    }

	 
	 
	@Override
	protected void drawBackEdges(Node<String> node) {
		for (RecursionStorage rs: recursions) {
			if (rs.node.equals(node)) {
				if (!repetitions.contains(""+node.hashCode()+"x"+rs.pointers.hashCode())) {
					repetitions.add("" + node.hashCode() + "x" + rs.pointers.hashCode());
					String str = ""+rs.counters.size();
					if (rs.counters.size()>1) {
						str = str + " [" + rs.extra.minNumberOfIterations +
						".." + rs.extra.maxNumberOfIterations + "]";
					}
					draw(rs.pointers.hashCode(), rs.node.hashCode(), str);
				} 
			}
		}
		
	}
	
	
	 protected boolean putUp(Node<String> node) {
		 if (!isEligible(node) && node.father!=null) {
			 for (RecursionStorage rs: recursions) {
				 if (rs.pointers.contains(node)) { 
					 rs.pointers.remove(node);
					 rs.pointers.add(node.father);
					 //System.out.println(rs.pointer.data);
				 }
			 }
		 } 
		return super.putUp(node);
	}

}
