package usi.instrumentation.tree;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Subgraph implements Comparable {
	
	public static Map<Integer, Subgraph> subgraphs = new HashMap<Integer, Subgraph>();
	
	private String name;
	private String desc;
	List<Integer> nodeIds;
	
	public Subgraph(String name, String desc) {
		this.setName(name);
		this.setDesc(desc);

	}
	
	public void addNode(int hashcode) {
		if (nodeIds == null) {
			nodeIds = new ArrayList<Integer>();
		}
		if (!nodeIds.contains(hashcode))
			nodeIds.add(hashcode);
	}
	
	public List<Integer> getNodeIds() {
		return nodeIds;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

	public void setDesc(String desc) {
		this.desc = desc;
	}
	
	public void appendDesc(String desc) {
		this.desc = this.desc + desc;
	}

	public String getDesc() {
		return desc;
	}

	@Override
	public int compareTo(Object obj) {
		if (obj instanceof Subgraph) {
			Subgraph sub = (Subgraph) obj;
			if (this.nodeIds.size()>sub.nodeIds.size()) {
				return 1;
			} else if (this.nodeIds.size()<sub.nodeIds.size()) {
				return -1;
			} else {
				return 0;
			}
		} else {
			throw new ClassCastException("Invalid object");  
		}
	
	}

}
